/*
 * Copyright (c) 1999, 2000 Greg Haerr <greg@censoft.com>
 *
 * Demo program for Microwindows
 */
 
/*
	by Phat Ho
	08/08/2000 Enjoy modifying the source code "button.c" to handle multiple
			set of radio buttons, every set must have id's aligned with 
			256 (0x100) boundaries
	12/11/2000 Finish adding digital video, requires the patcedh geode_v and realmagic installation in /sigma
		   Need /sigma/bravhart.pes
	12/15/2000 change decoder subaddr 9 from 0 to 84 for SVideo for high quality
		   Need to add control to subaddr 88 to power down unused analog channel 

*/
//#define NEW_VTEST
//#define videotest

#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h> 
//#include <fcntl.h>
//#include <unistd.h>
#include <sys/mman.h> 
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#define MWINCLUDECOLORS
#include "windows.h"
#include "wintern.h"		/* for MwRegisterFdInput*/
#include "wintools.h"
#include "device.h"
#include "wintern.h"		/* for MwSetDesktopWallpaper*/

/* These are needed to use the V4L2 driver */
#include <linux/fs.h>
#include <linux/kernel.h>
#include <linux/videodev.h>  /* Video for Linux Two */
#include <string.h>

#include "../../../../nsc_middleware/anlg_video.h"

#if DOS_TURBOC
unsigned _stklen = 4096;
#endif

#define CLIPDEMO	0	/* set for region clipping demo*/

#ifndef ELKS
#define TIMERDEMO	0	/* set for WM_TIMER demo*/
#define GRAPH3D		0	/* 3d graphics demo*/
#define IMAGE		0	/* 256 color image demo*/
#endif
#define ARCDEMO		0	/* arc drawing demo*/
#define CHILD 		1	/* child window demo*/
#define CLIENT3D	1	/* old client draw test*/

/* items ID */
#define IDC_GROUP1	11
#define	IDC_GROUP2	12
#define	IDC_GROUP3	13
#define IDC_GROUP4	14
#define IDC_GROUP5	15

#define IDC_TUNER	0x202 
#define IDC_VIDEO	0x200 
#define IDC_SVIDEO	0x201
#define IDC_DIGITAL	0x203
#define IDC_STREAM	0x204
#define IDC_PREF	0x205
#define IDC_CHNUM	0x206
 
#define IDC_CH		0x207
#define IDC_CH_UP	0x208
#define IDC_CH_DOWN	0x209

#define IDC_MODE1	0x301 
#define IDC_MODE2	0x302 
#define IDC_MODE3	0x303 
#define IDC_MODE4	0x304 
#define IDC_MODE5	0x305 
#define IDC_MODE6	0x306 
#define IDC_MODE7	0x307 
#define IDC_MODE8	0x308 
#define IDC_MODE9	0x309 

#define IDC_OPTION1	0x401 
#define IDC_OPTION2	0x402 
#define IDC_OPTION3	0x403 
#define IDC_OPTION4	0x404 
#define IDC_OPTION5	0x405 
#define IDC_OPTION6	0x406 
#define IDC_OPTION7	0x407 
#define IDC_OPTION8	0x408 
#define IDC_OPTION9	0x409 

#define IDC_CMD1	0x501 //Open video driver
#define IDC_CMD2	0x502 
#define IDC_CMD3	0x503 
#define IDC_CMD4	0x504 
#define IDC_CMD5	0x505 
#define IDC_CMD6	0x506 
#define IDC_CMD7	0x507 
#define IDC_CMD8	0x508 
#define IDC_CMD9	0x509 

#define IDC_STATUS	0x600 
#define IDC_DISPLAY	0x601

#if GRAPH3D
#include "graph3d.h"
#endif

extern MWIMAGEHDR image_nsc8;
extern MWIMAGEHDR image_nscmag8;
extern MWIMAGEHDR image_car8;
extern MWIMAGEHDR image_zion208;
extern MWIMAGEHDR image_penguin;
extern MWIMAGEHDR image_under4;
extern MWIMAGEHDR image_microwin;
extern MWIMAGEHDR image_cs1;
extern MWIMAGEHDR image_rle8;

#if CHILD
#if ELKS | MSDOS
PMWIMAGEHDR image = &image_cs1;		/* 2 color bitmap for 16 color systems*/
#else
PMWIMAGEHDR image = &image_penguin;
#endif
#endif

#if IMAGE
PMWIMAGEHDR image2 = &image_zion208;
#endif

#ifdef NEW_VTEST

#define MAINCLASS 	"main"

#endif

#define APPCLASS	"test"
#define APPCHILD	"test2"
#define CHCHILD		"channel"
#define STATUSCHILD	"status"
#define DISPLAYCHILD	"display"

#define COLS		80
#define ROWS		6
#define XMARGIN		4
#define YMARGIN		2
#define FGCOLOR		CYAN //GREEN
#define BKCOLOR		BLACK
#define FONTNAME	SYSTEM_FIXED_FONT
//------------------------------
// Close Caption
int ccLeft	=80;
int ccTop	=160;
#define CCCOLS		32
#define CCROWS		8
#define CCBKCOLOR	BLACK
COLORREF ccTextColor = WHITE;
BOOL	gOSD = FALSE;			/* On Screen Display */
BOOL	gCCbg = FALSE;			/* CC back ground mode */
BOOL	gFullBlend = FALSE;		/* use alpha blending to go full screen */
int	gLogo = 0;			/* use alpha blending to display logo */
int 	gSavedLogo = 0;
int 	gEnableScaling = 0;
int 	ccCharWidth2;
int 	ccCharWidth;
int	ccCharHeight;
/* forward decls*/
#ifdef NEW_VTEST
LRESULT CALLBACK MainWndProc(HWND hwnd,UINT uMsg,WPARAM wp,LPARAM lp);
#endif

LRESULT CALLBACK WndProc(HWND hwnd,UINT uMsg,WPARAM wp,LPARAM lp);
LRESULT CALLBACK ChildWndProc(HWND hwnd,UINT uMsg,WPARAM wp,LPARAM lp);
LRESULT CALLBACK ChEditWndProc(HWND hwnd,UINT uMsg,WPARAM wp,LPARAM lp);
LRESULT CALLBACK StatusWndProc(HWND hwnd,UINT uMsg,WPARAM wp,LPARAM lp);
LRESULT CALLBACK DisplayWndProc(HWND hwnd,UINT uMsg,WPARAM wp,LPARAM lp);

int OpenVideo();
int CloseVideo();
void EmOutChar(HWND hwnd, int ch);
int  CreatePtyShell(void);
int  ReadPtyShell(int fd, char *buf, int count);
int  WritePtyShell(int fd, char *buf, int count);
void ClosePtyShell(int fd);
int  SetChannel(int chnum);
void StatusOutStr(LPCSTR str);
int  decode_cc(int vbi);
int  get_cc();
int decode_raw( FILE* fp, int vbi );
int	test1();
int vcat();
//int AnimateClip(int delta);
//int DemoClipping();
//int DemoAlphaBlend();
//int SetCCBox(RECT rc);
int CheckCC();
int ChangeOSD();
int ChangeCCbground();
int ChangeFullBlend();
int FullScreen();
int SetLogo();
int SetOverLay(int x, int y, int wid, int height);
int ScaleToWindow();
int Scaling(int wid, int height);
//int AlphaTest(int wid, int height);
int SetVideoSize(int wid, int height);
int SetAlphaBlend(int wnum,RECT rc,int subcolor,int alphaval,int xoffs,int yoffs);
int encoder_enable();
void PlayMpeg(int mode);
int ChangeField();
void EnableChItems(int cmdShow, int selection);
int DebugDump();
int Pan(int adj);
int SetAudio(int selection,int mute, int incr);

int muting = 0;
int volumes[4] = { 15,95,95,30 }; //tuner,video,svideo,digital
int currentselection = 0;
int volume = 50;
int mpegPlaying = 0;

BOOL isFullScreen = FALSE;
int gDisplayX;
int gDisplayY;
int gDisplayW;
int gDisplayH;
static RECT mainRect,displayRect,gAlphaRect,gLogoRect;
/* local data*/
static int ttyfd = -1;
static int xpos = XMARGIN;
static int ypos = YMARGIN;
static int nCharWidth, nCharHeight;
static RECT ccBox = {0,0,0,0};

//static int nScreenWidth, nScreenHeight;

/* video driver */
#define MY_DEVICE "/dev/video0"
#define PETER_MAGENTA 0x00F000F0 
/* video globals */
int			vid = -1;
BOOL			gUseFile = FALSE;
int			overlay = -1;
int			vbi = -1;
#define CC_TIMER	1
#define CC_INTERVAL	10
#define MPEG_TIMER	2
#define MPEG_INTERVAL	7
/* globals */
int gChNum = 36;
HWND gHwnd = NULL;
HWND gStatusHwnd = NULL;
HWND gDisplayHwnd = NULL;

COLORREF gStatusColor = FGCOLOR;
int			raw_mode = 0;
//__u32			channel = 15;
char			mainstr[80];
int	gWidth = 720;
RECT	gRect = {10,10,210,330}; 
RECT	gClipRect = {10,10,210,330};

int gBufferOffset = (0xF0800+(40*2)); //center 640 in 720, 40 pixels adj

//---------------------------------------------- 
//for Sojan request, log the settings here so we can issue ioclt calls
int gDecoderW = 720;
int gDecoderH = 480;
int gOverlayX = 0;
int gOverlayY = 0;
int gOverlayW = 720;
int gOverlayH = 480;
//---------------------------------------------- //from the driver

//#define GEODE_IOCTL_SET_OVERLAY_INFO		0x00009000
//#define GEODE_IOCTL_SET_ALPHA_BLEND_INFO	0x00009001
//#define GEODE_IOCTL_STREAMON			0x00009002
//#define GEODE_IOCTL_STREAMOFF			0x00009003
//#define GEODE_IOCTL_DIAG			0x00009004
//#define GEODE_IOCTL_FIELDS			0x00009005
//==============
#define READ_VIP	2
#define WRITE_VIP	3
#define READ_REG	4
#define WRITE_REG	5
#define READ_DEC	6
#define WRITE_DEC	7
#define READ_VID	8
#define WRITE_VID	9

//----------------------------------------------
void IOCTL_Error(LPCSTR str, unsigned int rc)
{
	char tmp[128];
	sprintf(tmp,"%s %8.8X\r\n",str,rc);
	StatusOutStr(tmp);
}

/*typedef struct {
           int            TypeOfData;   // Is this data for Overlay or AlphaBlending or Palette
	                                // '1' for Overlay,'2' for Alpha and '3' for Palette data
           short          StartX;       // Start x coordinate of the Overlay window
           short          StartY;       // Start y coordinate of the Overlay window
	   unsigned short Width;        // Width of the Overlay window
	   unsigned short Height;       // Height of the Overlay window
	   unsigned long  BufferOffset; // Offset of the Start of Overlay buffer with
	                                // respect to start of Framebuffer.
	   unsigned short BufferWidth;  // Width of Overlay buffer in pixels.
	   unsigned short BufferHeight; // Height of Overlay buffer in pixels.
	   unsigned long  ColorKey;     // Colorkey to be used for Overlay.
	   unsigned long  ColorMask;    // Mask bits of the graphics or video stream being
	                                // compared to the Colorkey. This can be used to 
					// allow a range of values to be used as color key..
	   unsigned long  VideoFormat;  // Format of Overlay data : YUYV or 
	   int            Graphics;     // If '0' Video hardware will compare graphics data
	                                // to colorkey. If '1' Video data will be compared.
	   int            Enable;       // '0' for disable Overlay & '1' for enable.
} OVERLAY_INFO;*/


// Do we need to close the driver ?
int SetVideoSize(int wid, int height)
{
	struct v4l2_window window;
	int rc, vid2=0;
	
	vid2=vid;
	if(vid2 < 0)
		OpenVideo();
	memset(&window,0,sizeof(window));
	window.x = 0;//set_wnd_size.x;
	window.y = 0;//set_wnd_size.y;
	window.width = wid;//set_wnd_size.width;
	window.height = height;//set_wnd_size.height;
	//printf("setting window size\n");
	rc = ioctl( vid, VIDIOC_S_WIN, &window );

	if(rc < 0)
	{
		IOCTL_Error("Error: VIDIOC_S_WIN", rc);
	}
	if(vid2 < 0)
		CloseVideo(); 
	
	return rc;
}

int OpenVideo()
{
#if 1
	/* video driver */
	char	my_device[64];
	VIDEO_CAPABILITY	caps;
	char tmp[128];
	int rc;
//	char	device_label[96];

/*->	Put in the device node name */
	if(vid < 0)
	{
		//strcpy(my_device, MY_DEVICE);
		vid = open("/dev/video", O_RDONLY/*O_NONCAP*/);
		if (vid < 0)
		{
			
			sprintf(tmp,"No video device \"%s\"\r\n", my_device);
			StatusOutStr(tmp);
			return 1;
		}
		
		sprintf(tmp,"Driver instance = %d\r\n", vid);
		StatusOutStr(tmp);
		
		rc = ioctl(vid, VIDIOC_QUERYCAP, &caps);
		if(rc < 0)
		{
			IOCTL_Error("Error: VIDIOC_QUERYCAP", rc );
			return 1;
		}
		
		sprintf(tmp,"Device: \"%s\", %d inputs, max %d fps\r\n", 
			caps.name,caps.inputs,caps.maxframerate);
		StatusOutStr(tmp);
		
		//rc = SetChannel(gChNum);
		//if(rc < 0)
		//{
		//	return 1;
		//}
		//CloseVideo();
	}
	else
	{
		StatusOutStr("Already opened\r\n");
	}
#endif
return 0;
}

// Do we need to close the driver ?
int CloseVideo()
{
#if 1
	if(vid >= 0)
	{
		StatusOutStr("Close driver\r\n");
		close(vid);
	}
	else
	{
		StatusOutStr("No opened driver\r\n");	
	}
	vid = -1;
#endif
return 0;
}

void SetRawMode(BOOL bRaw)
{
	StatusOutStr(bRaw ? "Set raw\r\n" : "Set non-raw\r\n");
	raw_mode = bRaw;
}	    
//----------------------------------------------
void usage()
{
	printf("vbitest [-raw][-tune <channel>]\n");
}

int
MwUserInit(int argc, char **argv)
{
	int			args = 0;

	while( argc > ( args + 1 ) )
	{
		args++;
		if( strcmp(argv[args],"-tune") == 0 )
		{
			if( argc > args )
			{
				args++;
				gChNum = atoi(argv[args]);
				sprintf(mainstr,"tuning to channel %d\r\n", gChNum );
				printf("%s",mainstr);
			}
			else
			{
				usage();
				exit(1);
			}
		}
		else if( strcmp(argv[args],"-raw") == 0 )
		{
			raw_mode = 1;
			sprintf(mainstr,"raw mode\r\n");
			printf("%s",mainstr);
		}
	}
	/* test user init procedure - do nothing*/
	return 0;
}

int
RegisterAppClass(void)
{
	WNDCLASS	wc;

	//main window
	MwRegisterButtonControl(NULL);
	MwRegisterEditControl(NULL);
	MwRegisterListboxControl(NULL);
	MwRegisterProgressBarControl(NULL);
	//MwRegisterComboboxControl(NULL);
	MwRegisterStaticControl(NULL);

	wc.style = CS_DBLCLKS | CS_VREDRAW | CS_HREDRAW;
	wc.lpfnWndProc = (WNDPROC)WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = 0;
	wc.hIcon = 0; /*LoadIcon(GetHInstance(), MAKEINTRESOURCE( 1));*/
	wc.hCursor = 0; /*LoadCursor(NULL, IDC_ARROW);*/
	wc.hbrBackground = (HBRUSH)GetStockObject(LTGRAY_BRUSH);
	wc.lpszMenuName = NULL;
	wc.lpszClassName =  APPCLASS;
	RegisterClass( &wc);
#ifdef NEW_TEST
	wc.lpfnWndProc = (WNDPROC)MainWndProc;
	wc.lpszClassName =  MAINCLASS;
	RegisterClass( &wc);
#endif	
	//channel window
	wc.lpfnWndProc = (WNDPROC)ChEditWndProc;
	wc.lpszClassName =  CHCHILD;
	RegisterClass( &wc);

	//status window
	wc.lpfnWndProc = (WNDPROC)StatusWndProc;
	wc.lpszClassName =  STATUSCHILD;
	RegisterClass( &wc);
	//display window
	wc.lpfnWndProc = (WNDPROC)DisplayWndProc;
	wc.lpszClassName =  DISPLAYCHILD;
	RegisterClass( &wc);
	
#if CHILD
	wc.lpfnWndProc = (WNDPROC)ChildWndProc;
	wc.lpszClassName =  APPCHILD;
	return RegisterClass( &wc);
#endif
	return 1;
}


#define screenW		640
#define screenH		480

#define screenW		640
#define screenH		480
#define mainX		15
#define mainY		40

#define marginW		5
#define marginH		10
#define marginTop	10
#define marginBottom	10 
#define groupgapH	10
//#define gap		5 

#define videoW		(360+2)
#define videoH		(240+2)
#define videoX		3
#define videoY		marginTop

#define statusW		videoW //(videoW+panelW+marginW)
#define statusH		100
#define statusX		videoX
#define statusY		(videoY+videoH+groupgapH)

#define panelW		170
#define panelH		(videoH+groupgapH+statusH)
#define panelX		(videoX+videoW+marginW)
#define panelY		videoY

#define bottomAdj	15
#define rightAdj	3
#define mainW		(videoW+panelW+3*marginW+rightAdj)
#define mainH		(videoH+statusH+marginTop+groupgapH+marginBottom+bottomAdj)

#define controlX	(panelX+5)	//first control column offset 5
#define radioH		13
#define checkH		13
#define pushH		20
#define edittextH	20
#define rowgapH		6
#define rowmarginH	13
#define group1H 	(2*rowmarginH+radioH+rowgapH+pushH)
#define group2H 	(2*rowmarginH+3*radioH+2*rowgapH)	
#define group3H 	(2*rowmarginH+3*radioH+2*rowgapH)
#define group4H 	statusH
#define group1Y		panelY
#define group2Y		(group1Y+group1H+groupgapH)
#define group3Y		(group2Y+group2H+groupgapH)
#define group4Y		statusY

#define gapH		10
#define gapW		5
#define groupgapW	5
#define groupLeft	panelX
#define groupW		(panelW - (2*groupgapW) )
#define itemW		(panelW-5)	
#ifdef NEW_VTEST
//WTOP
#define WS_PLAIN (WS_OVERLAPPED)
#define WTOP_ID	1
#define WTOP_X	0
#define WTOP_Y	0
#define WTOP_W	640
#define WTOP_H	480

//WBOT
#define WBOT_ID	2
#define WBOT_X	5 //15
#define WBOT_Y	(480-80-5)
#define WBOT_W	(640-WBOT_X-WBOT_X)
#define WBOT_H	(80)
#endif
HWND
CreateAppWindow(void)
{
	HWND	hwnd;//,hlist, group2;
	HDC	hdc;
	static int nextid = 1;
	int x, y, X, Y;
	RECT r;
	GetWindowRect(GetDesktopWindow(), &r);

	SetAlphaBlend(0,r,0,-1,0,0);
	SetAlphaBlend(1,r,0,-1,0,0);
	SetAlphaBlend(2,r,0,-1,0,0); 

	hwnd = CreateWindowEx(0L, APPCLASS,
		"STB Video Test Suite",
		WS_OVERLAPPEDWINDOW | WS_VISIBLE,
		mainX, mainY,
		mainW, mainH,
		NULL, (HMENU)nextid++, NULL, NULL);
	gHwnd = hwnd;

#if CHILD
	if(hwnd) 
	{
	#if 1
	//the group static text
		x = panelX + 10;
		y = group1Y-5;
		CreateWindowEx(0L, "STATIC",//"BUTTON",
			" Source ",
			/*BS_GROUPBOX |*/ WS_CHILD | WS_VISIBLE,
			x, y, 45, 14,
			hwnd, (HMENU)IDC_GROUP1, NULL, NULL);
		y = group2Y-5;
		CreateWindowEx(0L, "STATIC",//"BUTTON",
			" Mode ",
			/*BS_GROUPBOX |*/ WS_CHILD | WS_VISIBLE,
			x, y, 35, 14,
			hwnd, (HMENU)IDC_GROUP2, NULL, NULL);

		y = group3Y-5;
		CreateWindowEx(0L, "STATIC",//"BUTTON",
			 " Options ",
			/*BS_GROUPBOX |*/ WS_CHILD | WS_VISIBLE,
			x, y, 55, 14,
			hwnd, (HMENU)IDC_GROUP3, NULL, NULL);

		y = group4Y-5;
		CreateWindowEx(0L, "STATIC",//"BUTTON",
			" Command ",
			/*BS_GROUPBOX |*/ WS_CHILD | WS_VISIBLE,
			x, y, 55, 14,
			hwnd, (HMENU)IDC_GROUP4, NULL, NULL);

//		y += group4H + groupgapH;
//		CreateWindowEx(0L, "STATIC",//"BUTTON",
//			" Status ",
//			/*BS_GROUPBOX |*/ WS_CHILD | WS_VISIBLE,
//			groupgapW+10, y, 55, 14,
//			hwnd, (HMENU)IDC_GROUP5, NULL, NULL);

	#endif
	
	//group1 -- Source 
		//the radio buttons Tuner-Video-SVideo
		X = x = controlX; Y = y = group1Y + rowmarginH;
		CreateWindowEx(0L, "BUTTON",
			"Tuner",
			BS_AUTORADIOBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, radioH,
			hwnd, (HMENU)IDC_TUNER, NULL, NULL);
		x += (itemW/3);
		CreateWindowEx(0L, "BUTTON",
			"Video",
			BS_AUTORADIOBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, radioH,
			hwnd, (HMENU)IDC_VIDEO, NULL, NULL);
		x += (itemW/3);
		CreateWindowEx(0L, "BUTTON",
			"SVideo",
			BS_AUTORADIOBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, radioH,
			hwnd, (HMENU)IDC_SVIDEO, NULL, NULL);
		//the edit box for channel
		x = X; y = Y + radioH + rowgapH;
		CreateWindowEx(0L, CHCHILD,
			"01",
			WS_BORDER | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, edittextH,
			hwnd, (HMENU)IDC_CH, NULL, NULL);
		x += (itemW/3);
		CreateWindowEx(0L, "BUTTON",
			"-",
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/6) - gapW, pushH,
			hwnd, (HMENU)IDC_CH_DOWN, NULL, NULL);
		x += (itemW/6);
		CreateWindowEx(0L, "BUTTON",
			"+",
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/6) - gapW, pushH,
			hwnd, (HMENU)IDC_CH_UP, NULL, NULL);

		x += (itemW/6);
		CreateWindowEx(0L, "BUTTON",
			"Digital",
			BS_AUTORADIOBUTTON | WS_CHILD | WS_VISIBLE,
			x, y+(pushH-radioH)/2, (itemW/3) - gapW, radioH,
			hwnd, (HMENU)IDC_DIGITAL, NULL, NULL);
						
	//group2 -- Mode
		X = x = controlX; Y = y = group2Y + rowmarginH;
		CreateWindowEx(0L, "BUTTON",
			"Mode1",
			BS_AUTORADIOBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, radioH,
			hwnd, (HMENU)IDC_MODE1, NULL, NULL);
		x += (itemW/3);
		CreateWindowEx(0L, "BUTTON",
			"Mode2", 
			BS_AUTORADIOBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, radioH,
			hwnd, (HMENU)IDC_MODE2, NULL, NULL);
		x += (itemW/3);
		CreateWindowEx(0L, "BUTTON",
			"Mode3",
			BS_AUTORADIOBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, radioH,
			hwnd, (HMENU)IDC_MODE3, NULL, NULL);

		x = X; y += radioH+rowgapH;
		CreateWindowEx(0L, "BUTTON",
			"Mode4",
			BS_AUTORADIOBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, radioH,
			hwnd, (HMENU)IDC_MODE4, NULL, NULL);
		x += (itemW/3);
		CreateWindowEx(0L, "BUTTON",
			"Mode5",
			BS_AUTORADIOBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, radioH,
			hwnd, (HMENU)IDC_MODE5, NULL, NULL);
		x += (itemW/3);
		CreateWindowEx(0L, "BUTTON",
			"Mode6",
			BS_AUTORADIOBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, radioH,
			hwnd, (HMENU)IDC_MODE6, NULL, NULL);

		x = X; y += radioH+rowgapH;
		CreateWindowEx(0L, "BUTTON",
			"< Pan",
			BS_AUTORADIOBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, radioH,
			hwnd, (HMENU)IDC_MODE7, NULL, NULL);
		x += (itemW/3);
		CreateWindowEx(0L, "BUTTON",
			"Reset",
			BS_AUTORADIOBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, radioH,
			hwnd, (HMENU)IDC_MODE8, NULL, NULL);
		x += (itemW/3);
		CreateWindowEx(0L, "BUTTON",
			"Pan >",
			BS_AUTORADIOBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, radioH,
			hwnd, (HMENU)IDC_MODE9, NULL, NULL); 
			
	//group3 -- Options
		X = x = controlX; Y = y = group3Y + rowmarginH;
		CreateWindowEx(0L, "BUTTON",
			" Raw ",
			BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, checkH,
			hwnd, (HMENU)IDC_OPTION1, NULL, NULL);
		x += (itemW/3);
		CreateWindowEx(0L, "BUTTON",
			"use file", 
			BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, checkH,
			hwnd, (HMENU)IDC_OPTION2, NULL, NULL);
		x += (itemW/3);
		CreateWindowEx(0L, "BUTTON",
			"CC",
			BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, checkH,
			hwnd, (HMENU)IDC_OPTION3, NULL, NULL);

		x = X; y += checkH+rowgapH;
		CreateWindowEx(0L, "BUTTON",
			"Option4",
			BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, checkH,
			hwnd, (HMENU)IDC_OPTION4, NULL, NULL);
		x += (itemW/3);
		CreateWindowEx(0L, "BUTTON",
			"Option5",
			BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, checkH,
			hwnd, (HMENU)IDC_OPTION5, NULL, NULL);
		x += (itemW/3);
		CreateWindowEx(0L, "BUTTON",
			"CC bg",
			BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, checkH,
			hwnd, (HMENU)IDC_OPTION6, NULL, NULL);

		x = X; y += checkH+rowgapH;
		CreateWindowEx(0L, "BUTTON",
			"Option7",
			BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, checkH,
			hwnd, (HMENU)IDC_OPTION7, NULL, NULL);
		x += (itemW/3);
		CreateWindowEx(0L, "BUTTON",
			"Logo",
			BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, checkH,
			hwnd, (HMENU)IDC_OPTION8, NULL, NULL);
		x += (itemW/3);
		CreateWindowEx(0L, "BUTTON",
			"Scale",
			BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, checkH,
			hwnd, (HMENU)IDC_OPTION9, NULL, NULL);
			
			
	//group4 -- Command
		X = x = controlX; Y = y = group4Y + rowmarginH;
		CreateWindowEx(0L, "BUTTON",
			"Open Drvr",
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, pushH,
			hwnd, (HMENU)IDC_CMD1, NULL, NULL);
		x += (itemW/3);
		CreateWindowEx(0L, "BUTTON",
			"Close Drvr", 
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, pushH,
			hwnd, (HMENU)IDC_CMD2, NULL, NULL);
		x += (itemW/3);
		CreateWindowEx(0L, "BUTTON",
			"cc",
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, pushH,
			hwnd, (HMENU)IDC_CMD3, NULL, NULL);

		x = X; y += pushH+rowgapH;
		CreateWindowEx(0L, "BUTTON",
			"Audio",
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, pushH,
			hwnd, (HMENU)IDC_CMD4, NULL, NULL);
		x += (itemW/3);
		CreateWindowEx(0L, "BUTTON",
			"Fields",
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, pushH,
			hwnd, (HMENU)IDC_CMD5, NULL, NULL);
		x += (itemW/3);
		CreateWindowEx(0L, "BUTTON",
			"Full scr",
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, pushH,
			hwnd, (HMENU)IDC_CMD6, NULL, NULL);

		x = X; y += pushH+rowgapH;
		CreateWindowEx(0L, "BUTTON",
			"Size",
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, pushH,
			hwnd, (HMENU)IDC_CMD7, NULL, NULL);
		x += (itemW/3);
		CreateWindowEx(0L, "BUTTON",
			"Encoder",
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, pushH,
			hwnd, (HMENU)IDC_CMD8, NULL, NULL);
		x += (itemW/3);
		CreateWindowEx(0L, "BUTTON",
			"Cinema",
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, (itemW/3) - gapW, pushH,
			hwnd, (HMENU)IDC_CMD9, NULL, NULL);

		//the status (edit) box
		//x = groupgapW+gapW; Y += group4H + gapH; y = Y;;
		gStatusHwnd = CreateWindowEx(0L, STATUSCHILD,
			"*************** Welcome to IACONSUI *************\n",
			WS_BORDER | WS_CHILD | WS_VISIBLE,
			statusX, statusY, 
			statusW, statusH,
			hwnd, (HMENU)IDC_STATUS, NULL, NULL);

		//the video window
		{
		x = gapW;
		y = groupgapW; // Y += group4H + gapH; y = Y;;
		gDisplayHwnd = CreateWindowEx(0L, DISPLAYCHILD,
			"display",
			WS_BORDER | WS_CHILD | WS_VISIBLE, 
			videoX, videoY, 
			videoW, videoH,
			hwnd, (HMENU)IDC_DISPLAY, NULL, NULL);
		gDisplayX = videoX;
		gDisplayY = videoY;
		gDisplayW = videoW;
		gDisplayH = videoH;
		hdc = GetDC(gDisplayHwnd);
		SetBkColor(hdc,CCBKCOLOR);// BKCOLOR
	    	SetBkMode(hdc, OPAQUE);
		SetTextColor(hdc, ccTextColor);	
		SelectObject(hdc, GetStockObject(OEM_FIXED_FONT));
		SetRect(&r, 0, 0, 0, 0);
		ccCharHeight = DrawText(hdc, "m", 1, &r, DT_CALCRECT);
		ccCharWidth2 = ccCharWidth = r.right;
		ccCharHeight = r.bottom;
		//ccxlimit += ccCharWidth*CCCOLS + ccLeft; 
		//ccylimit += ccCharHeight*CCROWS + ccTop;
		//gOvlBrush = CreateSolidBrush(PETER_MAGENTA); //MAGENTA 
		ReleaseDC(gDisplayHwnd, hdc);
	}
	/* determine TE size from font*/
	hdc = GetDC(NULL);
	SelectObject(hdc, GetStockObject(FONTNAME));
	SetRect(&r, 0, 0, 0, 0);
	nCharHeight = DrawText(hdc, "m", 1, &r, DT_CALCRECT);
	nCharWidth = r.right;
	
	//nScreenWidth = min(w, nCharWidth*COLS);
	//nScreenHeight = min(h, nCharHeight*ROWS);
	ReleaseDC(NULL, hdc);
	}
#endif
	return hwnd;
}


int SetChannel(int chnum)
{
	char	str[10];
	char	statusstr[80];
	HWND 	hwnd;
	int 	vid2,rc = 0;
	
	hwnd = GetDlgItem(gHwnd,IDC_CH);
	if(chnum == -1)
	chnum = 99;
	chnum %= 100;
	
	vid2=vid;
	if(vid2 < 0)
		OpenVideo();
	rc = ioctl(vid,VIDIOC_S_FREQ,&chnum);
	if(rc < 0)
	{
		IOCTL_Error("Error: VIDIOC_S_FREQ", rc);
	}
	else
	{					
		gChNum = chnum;
		sprintf(str,"%02d",gChNum);		
		SetWindowText(hwnd,str);
	
		sprintf(statusstr,"Set channel %02d\r\n",gChNum);
		StatusOutStr(statusstr);
	}
	if(vid2 < 0)
		CloseVideo(); 
	
	return rc;
}
LRESULT CALLBACK
ChEditWndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	//HDC		hdc;
	//RECT		rc;
	//PAINTSTRUCT	ps;
	char		key;
	int		chnum;
	
	PWNDCLASS pClass;
	WNDPROC WndProc ;
	pClass = MwFindClassByName("EDIT");
	WndProc = pClass->lpfnWndProc;

	//if(isFullScreen)
	//	return(0);	//a way to disable window
	switch(msg) 
	{
	case WM_CHAR:
	    key =  LOBYTE (wp);
	    if(key >= '0' && key <= '9')
	    {
		    chnum = gChNum % 10;
		    chnum *= 10;
		    chnum += (key - '0');
		    SetChannel(chnum);
		    return 0;
	    }
            if(key == 0x08)
	    {
		    chnum = gChNum / 10;
		    SetChannel(chnum);
		    return 0;
	    }
	    
	    return 0;
	default:
		return WndProc( hwnd, msg, wp, lp);
	}
	return( 0);
}

typedef struct diagnostic_info
{
	int		cmd;
	int		arg1;
	int		arg2;
	int		result[64];
} diagnostic_info_t;

int ParseLocalInput(char ch)
{
	static char localcmd[256];
	static int localindex = 0;
	char	cmd[10],tmp[80];
	int items,index;
	int error,count = 1;
	int vout = 0;
	diagnostic_info_t diag_info;
	if(localindex == 0 && (ch == '%' || ch == '.'))
		return 0; //end local input
	if(ch != '\r')
	{
		if(ch == '\b' && localindex)
			--localindex;
		else
			localcmd[localindex++] = ch;
	}
	else
	{	
		EmOutChar(gStatusHwnd, '\r');
		EmOutChar(gStatusHwnd, '\n');
		localcmd[localindex++] = 0;
		
		diag_info.arg2 = 1; //minimum count
		items = sscanf(localcmd,"%s %X %X",cmd,&diag_info.arg1,&diag_info.arg2);
		error = 0;
		if(items >= 2 && cmd[0] == 'r')
		{
			count = (items == 2) ? 1 : diag_info.arg2;
			switch(cmd[1])
			{
			case 'd':
				diag_info.cmd = READ_DEC;
				break;
			case 'p':
				diag_info.cmd = READ_VIP;
				break;
			case 'v':
				diag_info.cmd = READ_VID;
				break;
			case 'r':
				diag_info.cmd = READ_REG;
				break;
			default:
				error = 1;
				break;
			}	

		}
		else if(items == 3 && cmd[0] == 'w')
		{
			switch(cmd[1])
			{
			case 'd':
				diag_info.cmd = WRITE_DEC;
				break;
			case 'p':
				diag_info.cmd = WRITE_VIP;
				break;
			case 'v':
				diag_info.cmd = WRITE_VID;
				break;
			case 'r':
				diag_info.cmd = WRITE_REG;
				break;
			default:
				error = 1;
				break;
			}
			count = 1;	
		}
		else
		{
			StatusOutStr(localcmd);
			error = 1;
		}
		if( !error )
		{
			//sprintf(tmp,"%X %X",diag_info.arg1,diag_info.arg2 );
			//StatusOutStr(tmp);
			vout=open("/dev/vout", O_WRONLY);
			if(vout < 0)
			{
				StatusOutStr(" -- Cannot Open file /dev/vout");
			}
			else
			{
#if 0			
				if(0 > ioctl(vout, GEODE_IOCTL_DIAG, &diag_info))
				{
					StatusOutStr(" -- error");
				}
				else
#endif				
				{
					if(count == 1)
					{
						sprintf(tmp," -- %8.8X",diag_info.result[0]);
						StatusOutStr(tmp);
					}
					else
					{
						for(index = 0; index < count; index++)
						{
							if(cmd[1] != 'd') //4bytes
							{
								if(index && (index&7)==0)
									StatusOutStr("\r\n");	
								sprintf(tmp," %8.8X",diag_info.result[index]);
							}
							else //1byte
							{
								if(index && (index&15)==0)
									StatusOutStr("\r\n");	
								sprintf(tmp," %2.2X",diag_info.result[index]);
							}
							StatusOutStr(tmp);
						}
					
					}
				}
				close(vout);	
			}
		}
		localindex = 0;
	}
	return 1; //more
}

LRESULT CALLBACK
StatusWndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
static int escapemode = 0;
	unsigned char	ch;
	HDC		hdc;
	RECT		rc;
	PAINTSTRUCT	ps;
   	char	tmp[8];
	PWNDCLASS pClass;
	WNDPROC WndProc ;
	static int gLocalInput = 0;
	pClass = MwFindClassByName("EDIT");
	WndProc = pClass->lpfnWndProc;
	//if(isFullScreen)
	//	return(0);	//a way to disable window
	switch(msg) {
	case WM_CREATE:
		ttyfd = CreatePtyShell();
		/*if(ttyfd == -1)
			return -1;*/
		MwRegisterFdInput(hwnd, ttyfd);
		xpos = XMARGIN;
		ypos = YMARGIN;
		break;

	case WM_DESTROY:
		MwUnregisterFdInput(hwnd, ttyfd);
		ClosePtyShell(ttyfd);
		break;

	case WM_CHAR:
		ch = (char)wp;
		/* echo half duplex if CreatePtyShell() failed*/
		if(ttyfd == -1) {
			EmOutChar(hwnd, ch);
			if(ch == '\r')
				EmOutChar(hwnd, '\n');
		} 
		else if(gLocalInput)
		{
			gLocalInput = ParseLocalInput(ch);
			if(!gLocalInput)
				StatusOutStr(" end local input\r\n");
			else
			{
				EmOutChar(hwnd, ch);
				if(ch == '\r')
					EmOutChar(hwnd, '\n');
			}
		}
		else if(ch == '%' )
		{
			gLocalInput = 1;
			StatusOutStr("begin local input\r\n");
		}
		else
		{
			WritePtyShell(ttyfd, &ch, 1);
			if(escapemode == 0 && ch == 0x1b) //escape
			{
				escapemode = 0x1b;
			}
			else
			{
				switch(escapemode)
				{
				case 0x1b:
					if(ch == 0x1b)
						PostMessage(gHwnd, WM_CLOSE, 0, 0);	
					else if(ch != 0x5B)
					{
						sprintf(tmp,"-%2.2X-",ch);
						StatusOutStr(tmp);
						escapemode = 0;
					}
					else
						escapemode = ch;
					break;
				case 0x5B:
					switch(ch)
					{
					case 0x41: //up
					case 0x42: //down
						StatusOutStr("\r                                                 \r");
						break;
					case 0x43: //left
					case 0x44: //right
						break;
					default:
						sprintf(tmp,"-%2.2X-",ch);
						StatusOutStr(tmp);
						break;
					}
					escapemode = 0;;
					break;
				}
			}
		}
		break;

	case WM_FDINPUT:
		if(mainstr[0] != 0)
		{
			StatusOutStr(mainstr);
			mainstr[0] = 0;
		}
		else
		if(ReadPtyShell(ttyfd, &ch, 1) == 1)
			EmOutChar(hwnd, ch);
		break;

	case WM_PAINT:
		hdc = BeginPaint(hwnd, &ps);
		GetClientRect(hwnd, &rc);
		Draw3dInset(hdc, 0, 0, rc.right-rc.left, rc.bottom-rc.top);
		EndPaint(hwnd, &ps);
		break;

	default:
		return DefWindowProc(hwnd, msg, wp, lp);
	}
	return 0;
}
LRESULT CALLBACK
DisplayWndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	HDC		hdc;
	RECT		rc;
	PAINTSTRUCT	ps;
	HBRUSH		gOvlBrush;
	POINT		p1 = {0,0};
	char		key;
	
	switch(msg) {
	case WM_TIMER:
		if( wp == 11)
		{
			ScaleToWindow();
			KillTimer(gDisplayHwnd,11);
			if(gSavedLogo)
			{
				SetLogo(); //restart logo
				gSavedLogo = 0;
			}
		}
		else
		{
			if(gLogo & 1)
				SetAlphaBlend(1,gAlphaRect,0,0x000100,0,0); //transparent to opaque
			else
				SetAlphaBlend(1,gAlphaRect,0,0x00FFFF,0,0); //opaque to transparent
			++gLogo;
		}
		break;
	case WM_LBUTTONUP:
	case WM_CHAR:
		key =  LOBYTE (wp);
		if(key >= '0' && key <= '9')
		{
			SetChannel((gChNum % 10)*10 + (key - '0')) ;
		}
		else switch(key)
		{
			case '+': SetChannel(gChNum+1); break;	
			case '-': SetChannel(gChNum+11); break;
			case 't': EnableChItems(SW_SHOW,0); break;	
			case 's': EnableChItems(SW_HIDE,2); break; //IDC_SVIDEO	
			case 'v': EnableChItems(SW_HIDE,1); break; //IDC_VIDEO	
			case 'd': EnableChItems(SW_HIDE,3); break; //IDC_DIGITAL
			case 'f': ChangeField(); break;
			case 'l': SetLogo(); break;	
			case 'q': PostMessage(gHwnd, WM_CLOSE, 0, 0); break;	
			default: FullScreen(); break;
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hwnd, &ps);
		GetClientRect(hwnd, &rc);
		gOvlBrush = CreateSolidBrush(PETER_MAGENTA);
		FillRect(hdc, &rc, gOvlBrush);
		if(gLogo)
		{
			gLogoRect.left = rc.left + isFullScreen ? 44 : 4;
			gLogoRect.top = rc.top + isFullScreen ? 44 : 4;
			gLogoRect.right = gLogoRect.left + 239;
			gLogoRect.bottom = gLogoRect.top + 70;
			ClientToScreen(gDisplayHwnd,&p1);
			gAlphaRect.left = gLogoRect.left + p1.x;
			gAlphaRect.right = gLogoRect.right + p1.x;
			gAlphaRect.top = gLogoRect.top + p1.y;
			gAlphaRect.bottom = gLogoRect.bottom + p1.y;
			SetAlphaBlend(1,gAlphaRect,0,0x000000,0,0); //transparent to opaque
			DrawDIB(hdc, gLogoRect.left, gLogoRect.top, &image_nsc8);
			SetAlphaBlend(1,gAlphaRect,0,0x000100,0,0); //transparent to opaque
			gLogo |= 1; //sync
		}
	//GetClientRect(gDisplayHwnd, &gLogoRect);
		//DrawDIB(hdc, rc.left+ 40, rc.top+40, &image_car8);
		DeleteObject(gOvlBrush);
		EndPaint(hwnd, &ps);
		break;
	default:
		return DefWindowProc( hwnd, msg, wp, lp);
	}
	return( 0);
}


void CCRollup(int line)
{
	HDC	hdc;
	RECT	rc;
	HBRUSH 	gOvlBrush;	
	COLORREF ovlcolor = PETER_MAGENTA;
	int height = ccCharHeight*line;
	int height2= ccCharHeight*(CCROWS-line);
	int width = ccCharWidth2*CCCOLS;  
	
	SetRect(&rc, ccLeft, ccTop+height2, ccLeft+width, ccTop+height2+height);

	hdc = GetDC(gDisplayHwnd);
	BitBlt(hdc, ccLeft, ccTop, width ,height2,
		hdc, ccLeft, height+ccTop, SRCCOPY);
	
	gOvlBrush = CreateSolidBrush(ovlcolor);
	FillRect(hdc, &rc,gOvlBrush);
	DeleteObject(gOvlBrush);
	
	ReleaseDC(gDisplayHwnd, hdc);
}
int ClearCC = FALSE;
void CCOutChar(int ch, int row, int col, BOOL bDraw)
{
	HDC	hdc;
	RECT	rc;
	HBRUSH 	gOvlBrush; 
	int ccxpos;
	int ccypos;
	COLORREF ovlcolor = PETER_MAGENTA;
	int	charWidth = ccCharWidth2;
	int height = ccCharHeight;
	int width = charWidth; 

	POINT p1 = {0,0};
	
	if(ClearCC)
	{
		ClearCC = FALSE;
		CCOutChar(0,0,0,FALSE);
	}
	
	//coordinates may change
	ccxpos = col*charWidth + ccLeft;
	ccypos = row*height + ccTop;
	
	ClientToScreen(gDisplayHwnd,&p1);
	hdc = GetDC(gDisplayHwnd);
	if(ch == 0)
	{
		height *= (CCROWS);
		width *= (CCCOLS+2);
	}
	else if( ch == '\r' || ch == 0x10) //clear to the end of the line
	{
		width = (CCCOLS-col+1)*charWidth;
		ovlcolor = PETER_MAGENTA;
		bDraw = FALSE;
	}
	else if( ch == 0x08 ) //back space
		ovlcolor = PETER_MAGENTA; //RED;
	
	SetRect(&rc, ccxpos, ccypos, ccxpos+width, ccypos+height);
	if(bDraw)
	{
		SelectObject(hdc, GetStockObject(OEM_FIXED_FONT));
		SetBkColor(hdc,BKCOLOR);
		SetTextColor(hdc, gCCbg ? ovlcolor:ccTextColor); 		
		ExtTextOut(hdc, ccxpos, ccypos, ETO_OPAQUE, &rc, (char *)&ch, 1, NULL);
		ccxpos += charWidth;
		if(gCCbg)
		{
			if(ccBox.top == 0)
			{
				ccBox = rc;
			}
			else
			{
				if(ccBox.top > rc.top)
					ccBox.top = rc.top;
				if(ccBox.left > rc.left)
					ccBox.left = rc.left;
		
				if(ccBox.bottom < rc.bottom)
					ccBox.bottom = rc.bottom;
				if(ccBox.right < rc.right)
					ccBox.right = rc.right; 
			}
			//SetCCBox(ccBox);
			SetAlphaBlend(0,ccBox,0x01FFFFFF,0x50,p1.x,p1.y); //white text on translucent bground
		}
	}
	if(!bDraw) 
	{
		
		gOvlBrush = CreateSolidBrush(ovlcolor);
		FillRect(hdc, &rc,gOvlBrush);
		DeleteObject(gOvlBrush);
		ccBox.top = ccBox.left = ccBox.bottom = ccBox.right = 0;
		//SetCCBox(ccBox);
		SetAlphaBlend(0,ccBox,0,-1,0,0);
		if(ch == 0)
		{
			if(isFullScreen)
			{
				ccLeft = 160;
				ccTop = 300;
			}
			else
			{
				ccLeft = 80;
				ccTop = 160;
			}
		}
	}
	ReleaseDC(gDisplayHwnd, hdc);
#if 0
	switch(ch) {
	case '\r':
		xpos = XMARGIN;
		return;
	case '\n':
		ypos += nCharHeight;
		GetClientRect(hwnd, &rc);
		if(ypos > (ROWS-1)*nCharHeight + YMARGIN) {
			ypos -= nCharHeight;

			/* scroll window using bitblt ;-)*/
			hdc = GetDC(hwnd);
			BitBlt(hdc, XMARGIN, YMARGIN, rc.right-XMARGIN*2,
				rc.bottom-nCharHeight-YMARGIN*2,
				hdc, XMARGIN, nCharHeight+YMARGIN, SRCCOPY);
			rc.top = ypos;
			rc.left += XMARGIN;
			rc.right -= XMARGIN;
			rc.bottom -= YMARGIN;
			FillRect(hdc, &rc,
				(HBRUSH)GetClassLong(hwnd, GCL_HBRBACKGROUND));
			ReleaseDC(hwnd, hdc);
		}
		return;
	case '\007':			/* bel*/
		write(STDERR_FILENO, "\007", 1);
		return;
	case '\t':
		xpos += nCharWidth;
		while((xpos/nCharWidth) & 7)
			EmOutChar(hwnd, ' ');
		return;
	case '\b':
		if(xpos <= XMARGIN)
			return;
		xpos -= nCharWidth;
		EmOutChar(hwnd, ' ');
		xpos -= nCharWidth;
		return;
	}

	/* draw some text*/
	hdc = GetDC(hwnd);
	SelectObject(hdc, GetStockObject(FONTNAME));
	SetBkColor(hdc,GetSysColor(COLOR_BTNFACE));// BKCOLOR
	SetTextColor(hdc, gStatusColor);
	SetRect(&rc, xpos, ypos, xpos+nCharWidth, ypos+nCharHeight);
	ExtTextOut(hdc, xpos, ypos, ETO_OPAQUE, &rc, (char *)&ch, 1, NULL);
	ReleaseDC(hwnd, hdc);
	xpos += nCharWidth;
	if(xpos > (COLS-1)*nCharWidth) {
		xpos = XMARGIN;
		EmOutChar(hwnd, '\n');
	}
#endif
}


#if CHILD
LRESULT CALLBACK
ChildWndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	HDC		hdc;
	RECT		rc;
	PAINTSTRUCT	ps;

	switch(msg) {
	case WM_PAINT:
		hdc = BeginPaint(hwnd, &ps);
		GetClientRect(hwnd, &rc);
		DrawDIB(hdc, rc.left, rc.top, image);
		EndPaint(hwnd, &ps);
		break;
	default:
		return DefWindowProc( hwnd, msg, wp, lp);
	}
	return( 0);
}
#endif

void EnableChItems(int cmdShow, int selection)
{
	HWND	itemhwnd;
	int vid2,rc,sel;
	sel = selection;
    	itemhwnd = GetDlgItem(gHwnd,IDC_CH);
	ShowWindow(itemhwnd,cmdShow);
	//EnableWindow(itemhwnd,cmdShow == SW_SHOW);
    	itemhwnd = GetDlgItem(gHwnd,IDC_CH_UP);
	ShowWindow(itemhwnd,cmdShow);
	//EnableWindow(itemhwnd,cmdShow == SW_SHOW);
    	itemhwnd = GetDlgItem(gHwnd,IDC_CH_DOWN);
	ShowWindow(itemhwnd,cmdShow);
	//EnableWindow(itemhwnd,cmdShow == SW_SHOW);
	if(sel != 3 && mpegPlaying)
	{
		PlayMpeg(0);
	}
	
	vid2 = vid;
	//selection = 3; //fail test
	if(vid2 < 0)
		OpenVideo();
		
	rc = ioctl(vid, VIDIOC_S_INPUT, &selection);
	if(rc < 0)
	{
		IOCTL_Error("Error: VIDIOC_S_INPUT", rc );
	}
	if(vid2 < 0)
		CloseVideo();

	//requested by Sojan
	SetVideoSize(gDecoderW,gDecoderH);
	SetOverLay(gOverlayX,gOverlayY,gOverlayW,gOverlayH);

	if(sel == 3 /*&& !mpegPlaying*/) //digital video
	{
		if(mpegPlaying)
			PlayMpeg(0);
		PlayMpeg(1);
	}
	/*audio = open( "/dev/audio", O_RDONLY );
	if(audio < 0)
	{
		StatusOutStr("open audio failed\r\n");
	}
	else
	{
		close(audio);
	}*/
	SetAudio(selection,muting,0);
	SetFocus(gDisplayHwnd);
}

#include <linux/soundcard.h>

int SetAudio(int selection, int mute, int increment) 
{
static int mixdev[4] = { SOUND_MIXER_VIDEO,SOUND_MIXER_LINE,SOUND_MIXER_LINE,SOUND_MIXER_LINE1};
	
	char tmp[80];
	//mixer_info info;
	int mixer,rc,val; //audio,devmask;
	
	muting = mute;
	
		sprintf(tmp,"switch from %d to %d ", currentselection,selection);
		StatusOutStr(tmp);
	

	mixer = open( "/dev/mixer", O_RDONLY );
	if(mixer < 0)
	{
		StatusOutStr("open mixer failed\r\n"); //SOUND_MIXER_INFO
	}
	else
	{
		sprintf(tmp,"mixer = %X ", mixer);
		StatusOutStr(tmp);
		
		//mute the current selection
		if(selection != currentselection)
		{
			val = 0x0000;
			rc = ioctl(mixer, _IOC(_IOC_WRITE|_IOC_READ,'M',mixdev[currentselection],sizeof(int)), &val);
			if(rc < 0)
			{
				sprintf(tmp,"(%d)=_IOC_WRITE|_IOC_READ ", mixdev[currentselection]);
				StatusOutStr(tmp);	
			}
			rc = ioctl(mixer, _IOC(_IOC_READ,'M',mixdev[currentselection],sizeof(int)), &val);
			if(rc < 0)
			{
				sprintf(tmp,"(%d)=_IOC_READ ", mixdev[currentselection]);
				StatusOutStr(tmp);	
			}
			sprintf(tmp,"(%d)=%X ", mixdev[currentselection], val);
			StatusOutStr(tmp);
		}

		currentselection = selection;
		volume = volumes[currentselection];
		volume += increment;
		if(volume > 99)
			volume = 99;
		else if(volume < 1)
			volume = 1;
		volumes[currentselection] = volume;
		
		val = (muting) ? 0 : ((volume << 8) + volume);
		rc = ioctl(mixer, _IOC(_IOC_WRITE|_IOC_READ,'M',mixdev[currentselection],sizeof(int)), &val);
		if(rc < 0)
		{
			sprintf(tmp,"(%d)=_IOC_WRITE|_IOC_READ ", mixdev[currentselection]);
			StatusOutStr(tmp);	
		}
		rc = ioctl(mixer, _IOC(_IOC_READ,'M',mixdev[currentselection],sizeof(int)), &val);
		if(rc < 0)
		{
			sprintf(tmp,"(%d)=_IOC_READ ", mixdev[currentselection]);
			StatusOutStr(tmp);	
		}
		sprintf(tmp,"(%d)=%X ", mixdev[currentselection], val);
		StatusOutStr(tmp);
		
		StatusOutStr("\r\n");	
		close(mixer);
	}
	return 0;
}


LRESULT CALLBACK
WndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
#ifdef videotest
	HBRUSH		gOvlBrush;
#endif	
	PAINTSTRUCT	ps;
	HDC		hdc;
#if CLIENT3D | IMAGE | GRAPH3D
	RECT		rc;
#endif
#if GRAPH3D
	int		id;
	static vec1 	gx, gy;
#endif
#if TIMERDEMO
	static POINT	mousept;
	static int	countup = 1;
#endif
#if ARCDEMO
	static int	startdegrees = 0;
	static int	enddegrees = 30;
#endif
	//static int	testcount = 0;
	BOOL bButtonClick = HIWORD(wp) == BN_CLICKED;
	//char	tmpstr[80];
	HWND	itemhwnd;
	int	x,y;
	
	switch( msg) {
	/*case WM_KEYDOWN:
	case WM_CHAR:
	{	
            int id = LOWORD(wp);
            int i;
		
	    itemhwnd = GetDlgItem(hwnd,id);

	    switch(id)
	    {
	    case IDC_CH:
	    	++i;
	    	break;
	    
	    case IDC_STATUS:
	    	++i;
	    	break;
	    }
	    return DefWindowProc( hwnd, msg, wp, lp);
	    break;
	}*/
	case WM_COMMAND:
        if(bButtonClick )
	{
            int id = LOWORD(wp);
            //int i;
	    //if(isFullScreen)
	    //	return 0;
	    	
	    itemhwnd = GetDlgItem(hwnd,id);

	    switch(id)
	    {
	    case IDC_CH_UP:
	    	SetChannel(gChNum+1);
		StatusOutStr("Channel Up\r\n");
		break;
	    case IDC_CH_DOWN:
	    	SetChannel(gChNum-1);
		StatusOutStr("Channel Down\r\n");
		break;
	    case IDC_VIDEO:
	    	EnableChItems(SW_HIDE,1);
		StatusOutStr("Select Video\r\n");
	    	break;
	    case IDC_SVIDEO:
	    	EnableChItems(SW_HIDE,2);
		StatusOutStr("Select SVideo\r\n");
	    	break;
	    case IDC_DIGITAL:
	    	EnableChItems(SW_HIDE,3);
		StatusOutStr("Select Digital Video\r\n");
	    	break;
	    case IDC_TUNER:
	    	EnableChItems(SW_SHOW,0);
		StatusOutStr("Select Tuner\r\n");
	    	break;
	    case IDC_MODE1: StatusOutStr("Select mode1\r\n"); break;
	    case IDC_MODE2: StatusOutStr("Select mode2\r\n"); break;
	    case IDC_MODE3: StatusOutStr("Select mode4\r\n"); break;
	    case IDC_MODE4: StatusOutStr("Select mode4\r\n"); break;
	    case IDC_MODE5: StatusOutStr("Select mode5\r\n"); break;
	    case IDC_MODE6: StatusOutStr("Select mode6\r\n"); break;
	    case IDC_MODE7: Pan(-1); break;
	    case IDC_MODE8: Pan(0); break;
	    case IDC_MODE9: Pan(1); break;

	    case IDC_OPTION1:
	    	{
			SetRawMode(SendMessage(itemhwnd,BM_GETCHECK,0,0));
			break;
		}
	    case IDC_OPTION2: gUseFile = SendMessage(itemhwnd,BM_GETCHECK,0,0) ; break;
	    case IDC_OPTION3: ChangeOSD(); break;
	    case IDC_OPTION4: SetAudio(currentselection,muting=0,1); break;
	    case IDC_OPTION5: SetAudio(currentselection,muting=0,-1); break;
	    case IDC_OPTION6: ChangeCCbground(); break;
	    case IDC_OPTION7: SetAudio(currentselection,SendMessage(itemhwnd,BM_GETCHECK,0,0),0); break;

	    case IDC_OPTION8: SetLogo(); break;
	    case IDC_OPTION9: gEnableScaling = SendMessage(itemhwnd,BM_GETCHECK,0,0); break; //ChangeFullBlend(); 
	    
	    case IDC_CMD1: OpenVideo(); break;
	    case IDC_CMD2: CloseVideo(); break;
	    case IDC_CMD3: get_cc(); break;
	    case IDC_CMD4: SetAudio(currentselection,muting,0); break; //test1();
	    case IDC_CMD5: ChangeField(); break; //Scaling(360,240); 
	    case IDC_CMD6: gFullBlend = 0; FullScreen(); break;
	    case IDC_CMD7: DebugDump(); break; 
	    case IDC_CMD8: encoder_enable(); break;	//AlphaTest(100,200); 
	    case IDC_CMD9: gFullBlend = 1; FullScreen(); break; //AnimateClip(1); 
	    default:
            	/*if (id == IDC_CHECK1 && HIWORD(wp) == BN_CLICKED)
	    	{
                	SetFocus(hwnd);
			PostMessage(itemhwnd, WM_CLOSE, 0, 0);
	    	}
	    	else*/
	    	{
	    		return DefWindowProc( hwnd, msg, wp, lp);
	    	}
		break;
	    } // switch
        }
	else
	{
		return DefWindowProc( hwnd, msg, wp, lp);
	}
		break;	
	//case WM_NCLBUTTONDOWN:
	//	++testcount;
	//	break;
	case WM_TIMER:
		if(wp == CC_TIMER && !raw_mode)
		{
			while(CheckCC())
			{
				//Sleep(10);
				//empty the cc buffer
			}
		}
		else if(wp == MPEG_TIMER )
		{
			PlayMpeg(2);
		}
		/*else if(wp == 2)
		{
			DemoClipping();
		}*/
		/*else if(wp == 3)
		{
			DemoAlphaBlend();
		}*/
		/*
		else if( wp == 10)
		{
			if(gLogo & 1)
				SetAlphaBlend(1,gAlphaRect,0,0x00FFFF,0,0); //opaque to transparent
			else
			{
				SetAlphaBlend(1,gAlphaRect,0,0x000100,0,0); //transparent to opaque
			}
			++gLogo;
		}
		*/
		break;
	//case WM_DESTROY:
	case WM_CLOSE:
	//case WM_QUIT:
	
		KillTimer(gHwnd, 1);
		if(mpegPlaying)
			PlayMpeg(0);
		
		gOverlayW = 720;
		gOverlayH = 480;
		gOverlayX = gOverlayY = 0;
		SetOverLay(gOverlayX, gOverlayY, gOverlayW, gOverlayH);
		if(vbi >= 0)
			close(vbi);
		//if(vid >= 0)
		//	close(vid);
		
		
//		VMW_AVS_VideoClose();

		PostQuitMessage(0);
		break;
#if TIMERDEMO
	case WM_CREATE:
		SetTimer(hwnd, 1, 100, NULL);
		mousept.x = 60;
		mousept.y = 20;
		break;

	case WM_TIMER:
//		KillTimer(gHwnd,1);
//		PostMessage(gHwnd,WM_COMMAND,(BN_CLICKED<<16)+IDC_CMD3,0);
#if 0
#if GRAPH3D
		GetClientRect(hwnd, &rc);
		if(countup) {
			mousept.y += 20;
			if(mousept.y >= rc.bottom) {
				mousept.y -= 20;
				countup = 0;
			}
		} else {
			mousept.y -= 20;
			if(mousept.y < 20) {
				mousept.y += 20;
				countup = 1;
			}
		}
		SendMessage(hwnd, WM_MOUSEMOVE, 0,
			MAKELONG(mousept.x, mousept.y));
#endif
#if ARCDEMO
		startdegrees += 10;
		if(startdegrees >= 360)
			startdegrees = 0;
		enddegrees += 15;
		if(enddegrees >= 360)
			enddegrees = 0;
		InvalidateRect(hwnd, NULL, TRUE);
#endif
#endif
		break;

#endif /* TIMERDEMO*/
	case WM_SIZE:
		break;

	case WM_MOVE:
		break;

#if CLIENT3D
	case WM_SETFOCUS:
		PostMessage((HWND)wp, WM_PAINT, 0, 0L);
		break;

	case WM_KILLFOCUS:
		PostMessage((HWND)wp, WM_PAINT, 0, 0L);
		break;
	case WM_ERASEBKGND:
		if(GetFocus() != hwnd)
			return DefWindowProc(hwnd, msg, wp, lp);
		return 1;
#endif
#if GRAPH3D
	case WM_ERASEBKGND:
		if((GetWindowLong(hwnd, GWL_ID) & 03) == 1)
			return 1;
		return DefWindowProc(hwnd, msg, wp, lp);
#endif
	case WM_PAINT:
		hdc = BeginPaint(hwnd, &ps);
#ifdef videotest		
		GetClientRect(hwnd, &rc);
		gOvlBrush = CreateSolidBrush(PETER_MAGENTA);
		FillRect(hdc, &rc, gOvlBrush);
#endif
		// vertical line separator
		//MoveToEx(hdc, datapaneW, groupgapH, NULL);
		//LineTo(hdc,datapaneW, windowH-groupgapH-20);
		//SetBkColor(hdc,GetSysColor(COLOR_BTNFACE));
		//SetTextColor (hdc,GetSysColor(COLOR_BTNFACE));
		x = panelX; 
		y = group1Y;
		//Rectangle(hdc,x,y,x+groupW,y+group1H);
		MoveToEx(hdc, x, y, NULL);
		LineTo(hdc,x+panelW,y);
		LineTo(hdc,x+panelW,y+group1H);
		LineTo(hdc,x,y+group1H);
		LineTo(hdc,x,y);
		//TextOut(hdc,x+gapW,y-gapH," Source ",-1);
		
		y = group2Y;
		//Rectangle(hdc,x,y,x+groupW,y+group2H);
		MoveToEx(hdc, x, y, NULL);
		LineTo(hdc,x+panelW,y);
		LineTo(hdc,x+panelW,y+group2H);
		LineTo(hdc,x,y+group2H);
		LineTo(hdc,x,y);
		//TextOut(hdc,x+gapW,y-gapH," Mode ",-1);
		
		y = group3Y;
		//Rectangle(hdc,x,y,x+groupW,y+group3H);
		MoveToEx(hdc, x, y, NULL);
		LineTo(hdc,x+panelW,y);
		LineTo(hdc,x+panelW,y+group3H);
		LineTo(hdc,x,y+group3H);
		LineTo(hdc,x,y);
		//TextOut(hdc,x+gapW,y-gapH," Option s",-1);
		
//		y += group3H + groupgapH;
		y = group4Y;
		//Rectangle(hdc,x,y,x+groupW,y+group4H);
		MoveToEx(hdc, x, y, NULL);
		LineTo(hdc,x+panelW,y);
		LineTo(hdc,x+panelW,y+statusH-1); //group4H
		LineTo(hdc,x,       y+statusH-1);
		LineTo(hdc,x,y);
		//TextOut(hdc,x+gapW,y-gapH," Command ",-1);

//		y += group4H + groupgapH;
//		x = groupgapW;
		//Rectangle(hdc,x,y,x+groupW,y+group4H);
//		MoveToEx(hdc, x, y, NULL);
//		x = windowW - groupgapW - rightAdj;
//		LineTo(hdc,x,y);
//		LineTo(hdc,x,windowH - groupgapH - bottomAdj);
//		LineTo(hdc,groupgapW,windowH - groupgapH - bottomAdj);
//		LineTo(hdc,groupgapW,y);
		//TextOut(hdc,x+gapW,y-gapH," Command ",-1);
#if CLIENT3D
		if(GetFocus() == hwnd) {
			GetClientRect(hwnd, &rc);
			Draw3dShadow(hdc, rc.left, rc.top,
				rc.right-rc.left, rc.bottom-rc.top,
				GetSysColor(COLOR_3DDKSHADOW),
				GetSysColor(COLOR_3DLIGHT));
			InflateRect(&rc, -1, -1);
			FillRect(hdc, &rc, GetStockObject(GRAY_BRUSH));
		}
#endif
#if IMAGE
		GetClientRect(hwnd, &rc);
		DrawDIB(hdc, rc.left+2, rc.top+2, image2);
#endif
#if ARCDEMO
{
	int x, y, w, h;
	RECT rc;

	if(hdc != NULL) {
		GetWindowRect(hwnd, &rc);
		rc.top += 13;
		InflateRect(&rc, -3, -3);
		//Ellipse(hdc, 0, 0, rc.right-rc.left, rc.bottom-rc.top);
		//Arc(hdc, 0, 0, rc.right-rc.left, rc.bottom-rc.top, 0,0, 0,0);
		//Pie(hdc, 0, 0, rc.right-rc.left, rc.bottom-rc.top, 0,0, 0,0);
#if 1
		x = rc.left;
		y = rc.top;
		w = rc.right - rc.left;
		h = rc.bottom - rc.top;
		w += 10;
		GdSetForeground(GdFindColor(RGB(0,255,0)));
		GdArcAngle(hdc->psd, x+w/2, y+h/2, w/2, h/2, startdegrees*64,
			enddegrees*64, MWPIE);
		GdSetForeground(GdFindColor(RGB(0,0,0)));
		GdArcAngle(hdc->psd, x+w/2, y+h/2, w/2, h/2, startdegrees*64,
			enddegrees*64, MWARCOUTLINE);
		//GdSetForeground(GdFindColor(RGB(255,255,255)));
		//GdPoint(hdc->psd, x+w/2, y+h/2);
#endif
	}
	EndPaint(hwnd, &ps);
	break;
}
#endif /* ARCDEMO*/
#if GRAPH3D
		id = (int)GetWindowLong(hwnd, GWL_ID) & 03;
		init3(hdc, id == 1? hwnd: NULL);
		switch(id) {
		case 0:
			rose(1.0, 7, 13);
			break;
		case 1:
			//look3(0.5, 0.7, 1.5);
			//look3(0.2, -2 * gy, 1.0+gx);
			look3(-2 * gx, -2 * gy, 1.2);
			drawgrid(-8.0, 8.0, 10, -8.0, 8.0, 10);
			break;
		case 2:
			setcolor3(BLACK);
			circle3(1.0);
			break;
		case 3:
			setcolor3(BLUE);
			daisy(1.0, 20);
			break;
		}

#if CLIPDEMO
		if(id == 1) {
			HRGN	hrgn, hrgn2;

			/* create circular clip region for effect*/
			GetClientRect(hwnd, &rc);
			InflateRect(&rc, -80, -80);
			switch((int)GetWindowLong(hwnd, GWL_ID)) {
			default:
				hrgn = CreateEllipticRgnIndirect(&rc);
				break;
			case 5:
				hrgn = CreateRoundRectRgn(rc.left, rc.top,
					rc.right, rc.bottom, 100, 100);
				break;
			case 1:
				hrgn = CreateRectRgnIndirect(&rc);
				break;
			}

			/* erase background, clip out blit area*/
			GetClientRect(hwnd, &rc);
			hrgn2 = CreateRectRgnIndirect(&rc);
			SelectClipRgn(hdc, hrgn2);
			ExtSelectClipRgn(hdc, hrgn, RGN_XOR);
			DeleteObject(hrgn2);

			GetClientRect(hwnd, &rc);
			FillRect(hdc, &rc, GetStockObject(BLACK_BRUSH));

			/* clip in only blit area*/
			SelectClipRgn(hdc, hrgn);
			DeleteObject(hrgn);
		}
#endif /* CLIPDEMO*/

		paint3(hdc);

#endif /* GRAPH3D*/
		EndPaint(hwnd, &ps);
		break;

	case WM_LBUTTONDOWN:
		break;

	case WM_MOUSEMOVE:
#if GRAPH3D
		if((GetWindowLong(hwnd, GWL_ID) & 03) == 1) {
			POINT pt;

			POINTSTOPOINT(pt, lp);
			GetClientRect(hwnd, &rc);
			gx = (vec1)pt.x / rc.right;
			gy = (vec1)pt.y / rc.bottom;
			InvalidateRect(hwnd, NULL, FALSE);
			mousept.x = pt.x;
			mousept.y = pt.y;
		}
#endif
		break;

	case WM_LBUTTONUP:
		break;

	case WM_RBUTTONDOWN:
		break;

	default:
		return DefWindowProc( hwnd, msg, wp, lp);
	}
	return( 0);
}

char buff[20];
void callback(int a, void * data)
{
	printf("Hello\n");
}

int test1()
{
	int err;
//	VMW_VIDEO myvideo;
	VIDEO_CAPABILITY capability;
	VIDEO_FMTDESC format;
	VIDEO_FMTDESC fbformat;
	VIDEO_FORMAT vidformat;
	VIDEO_COMPRESSION comp ;
	VIDEO_INPUT inp;
	VIDEO_TUNER tuner;
	VIDEO_AUDIO audio;

//	VIDEO_FORMAT vbiformat;
//	ENUM_STANDARD enumstd;
//	VIDEO_STANDARD vidstd;



	
//	char * buffer ;
	u32 index;
	unsigned long freq = 10;

	inp.index = 0;
	tuner.input = 0;

	vidformat.type = V4L2_BUF_TYPE_CAPTURE;

	format.index = 0;
	fbformat.index = 0;
	
	//err = VMW_VideoInit("/dev/video1",VIDEO_NOIO,&myvideo);
	err = VMW_AVS_VideoInit();

	printf("%d\n", err);

	MSG("Yoohoo\n");
	DBG("Yoohoo\n");

	//err = VMW_GetVideoCapabilities(&capability, &myvideo);
	err = VMW_AVS_GetVideoCapabilities(&capability);
	printf("%d\n", err);
		printf("Device: \"%s\", %d inputs, max %d fps\r\n", 
			capability.name,capability.inputs,capability.maxframerate);

#if 1
	//err = VMW_EnumPixelFormat(&format, &myvideo);
//	err = VMW_AVS_EnumPixelFormat(&format);
//	printf("%d\n", err);

	//err = VMW_EnumFrameBufferFormat(&fbformat,&myvideo);
//	err = VMW_AVS_EnumFrameBufferFormat(&fbformat);
	printf("%d\n", err);
	
	//err = VMW_GetCaptureFormat(&vidformat, &myvideo);
	err = VMW_AVC_GetCaptureFormat(&vidformat);
	printf("%d\n", err);

	//err = VMW_SetCaptureFormat(&vidformat, &myvideo);
//	err = VMW_AVC_SetCaptureFormat(&vidformat);
	printf("%d\n", err);

	//err = VMW_GetCompFormat(&comp,&myvideo);
	//err = VMW_AVC_GetCompFormat(&comp);
	//printf("%d\n", err);
	
	//err = VMW_SetCompFormat(&comp,&myvideo);
//	err = VMW_AVC_SetCompFormat(&comp);
	printf("%d\n", err);

	//err = VMW_EnumVideoInput(&inp,&myvideo);
	err = VMW_AVS_EnumVideoInput(&inp);
	printf("%d\n%s\n", err, inp.name);

	//err = VMW_GetCurrentVideoInput(&index,&myvideo);
	err = VMW_AVS_GetCurrentVideoInput(&index);
	printf("%d\n", err);

	//err = VMW_SetCurrentVideoInput(&index,&myvideo);
	err = VMW_AVS_SetCurrentVideoInput(&index);
	printf("%d::%d\n", err, index);

	//err = VMW_GetTunerCapabilities(&tuner,&myvideo);
	err = VMW_AVT_GetTunerCapabilities(&tuner);
	printf("%d\n", err);

	//err = VMW_SetTunerCapabilities(&tuner,&myvideo);
	err = VMW_AVT_SetTunerCapabilities(&tuner);
	printf("%d\n", err);

//	err = VMW_GetTunerFrequency(&freq,&myvideo);
	err = VMW_AVT_GetTunerFrequency(&freq);
	printf("%d\n", err);

	//err = VMW_SetTunerFrequency(&freq,&myvideo);
	err = VMW_AVT_SetTunerFrequency(&freq);
	printf("%d\n", err);
	
	//err = VMW_GetAudioCapabilities(&audio,&myvideo);
	err = VMW_AVA_GetAudioCapabilities(&audio);
	printf("%d\n", err);

	//err = VMW_SetAudioCapabilities(&audio,&myvideo);
	err = VMW_AVA_SetAudioCapabilities(&audio);
	printf("%d\n", err);

	err = VMW_AVV_SetupVBICallback(callback,buff,20,(void*)buff);
	printf("%d\n", err);

	VMW_AVV_EnableVBICapture(1);	

	printf("%d\n", VMW_AVS_SetControl(AVS_CONTROL_BRIGHT,10));
#endif	
	return 0;	
}

int WINAPI 
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine,
	int nShowCmd)
{
	MSG 	msg;
	HWND	hwnd;
	RECT	rc;
	int audio;

	//test1();
	
	
	RegisterAppClass();
	GetWindowRect(GetDesktopWindow(), &rc);
	
	
#if !(ELKS | MSDOS)
	/* create penguin window*/
/*	CreateWindowEx(0L, APPCHILD, "", WS_BORDER | WS_VISIBLE,
		rc.right-130-1, rc.bottom-153-1, 130, 153,
		GetDesktopWindow(), (HMENU)1000, NULL, NULL);*/
#endif
//	CreateAppWindow();
#if !(ELKS | MSDOS)
	hwnd = CreateAppWindow(); 
//	GetWindowRect(hwnd, &rc);
//	OffsetRect(&rc, 150, 150);
//	MoveWindow(hwnd, rc.left, rc.top, rc.bottom-rc.top,
//		rc.right-rc.left, TRUE);
#endif
#if !(ELKS | MSDOS)
	/* set background wallpaper*/
//	MwSetDesktopWallpaper(&image_microwin);
	/*MwSetDesktopWallpaper(&image_under4);*/
	/*MwSetDesktopWallpaper(&image_car8);*/
#endif
	/* type ESC to quit...*/
	audio = open( "/dev/audio", O_RDONLY );
	close(audio);

	SetChannel(gChNum);
	EnableChItems(SW_SHOW,0);
	StatusOutStr("Select Tuner\r\n");
	
	//moved to EnableChItems
	//SetVideoSize(gDecoderW,gDecoderH);
	//SetOverLay(gOverlayX,gOverlayY,gOverlayW,gOverlayH);
	
	//gFullBlend = 0;
	//FullScreen();
	//SetTimer(gHwnd, 1, 5, NULL); //WM_TIMER
	while( GetMessage(&msg, NULL, 0, 0)) {
		//if(isFullScreen)
		//	SetFocus(gDisplayHwnd);
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return 0;
}

//------------------------------------------------
void
StatusOutStr(LPCSTR str)
{
	char c;
	gStatusColor = RED;
	while(0 != (c = *str++))
	{
		EmOutChar(gStatusHwnd,c);	
	}
	gStatusColor = FGCOLOR;
}
void
EmOutChar(HWND hwnd, int ch)
{
	HDC	hdc;
	RECT	rc;

	switch(ch) {
	case '\r':
		xpos = XMARGIN;
		return;
	case '\n':
		ypos += nCharHeight;
		GetClientRect(hwnd, &rc);
		if(ypos > (ROWS-1)*nCharHeight + YMARGIN) {
			ypos -= nCharHeight;

			/* scroll window using bitblt ;-)*/
			hdc = GetDC(hwnd);
			BitBlt(hdc, XMARGIN, YMARGIN, rc.right-XMARGIN*2,
				rc.bottom-nCharHeight-YMARGIN*2,
				hdc, XMARGIN, nCharHeight+YMARGIN, SRCCOPY);
			rc.top = ypos;
			rc.left += XMARGIN;
			rc.right -= XMARGIN;
			rc.bottom -= YMARGIN;
			FillRect(hdc, &rc,
				(HBRUSH)GetClassLong(hwnd, GCL_HBRBACKGROUND));
			ReleaseDC(hwnd, hdc);
		}
		return;
	case '\007':			/* bel*/
		write(STDERR_FILENO, "\007", 1);
		return;
	case '\t':
		xpos += nCharWidth;
		while((xpos/nCharWidth) & 7)
			EmOutChar(hwnd, ' ');
		return;
	case '\b':
		if(xpos <= XMARGIN)
			return;
		xpos -= nCharWidth;
		EmOutChar(hwnd, ' ');
		xpos -= nCharWidth;
		return;
	}

	/* draw some text*/
	hdc = GetDC(hwnd);
	SelectObject(hdc, GetStockObject(FONTNAME));
	SetBkColor(hdc,GetSysColor(COLOR_BTNFACE));// BKCOLOR
	SetTextColor(hdc, gStatusColor);
	SetRect(&rc, xpos, ypos, xpos+nCharWidth, ypos+nCharHeight);
	ExtTextOut(hdc, xpos, ypos, ETO_OPAQUE, &rc, (char *)&ch, 1, NULL);
	ReleaseDC(hwnd, hdc);
	xpos += nCharWidth;
	if(xpos > (COLS-1)*nCharWidth) {
		xpos = XMARGIN;
		EmOutChar(hwnd, '\n');
	}
}

#if ELKS
#define SHELL	"/bin/sash"
#else
#if DOS_DJGPP
#define SHELL	"bash"
#else
#define SHELL	"/bin/sh"
#endif
#endif

static int pid;

static void
ptysignaled(int signo)
{
	switch(signo) {
	case SIGINT:	/* interrupt*/
#if !ELKS
		/* this doesn't work, can anyone fix it?*/
		killpg(pid, SIGINT);
#endif
		return;
	case SIGCHLD:	/* child status change - child exit*/
		DestroyWindow(GetActiveWindow());
		CreateAppWindow();
		return;
	}
	fprintf(stderr, "Uncaught signal %d\n", signo);
}

/*
 * Create a shell running through a pseudo tty, return the shell fd.
 */
int
CreatePtyShell(void)
{
	int	n = 0;
	int	tfd;
	char	pty_name[12];
	char *	argv[2];

again:
	sprintf(pty_name, "/dev/ptyp%d", n);
	if ((tfd = open(pty_name, O_RDWR | O_NONBLOCK)) < 0) {
		if ((errno == EBUSY || errno == EIO) && n < 10) {
			++n;
			goto again;
		}
		fprintf(stderr, "Can't create pty %s\n", pty_name);
		return -1;
	}
	signal(SIGCHLD, ptysignaled);
	signal(SIGINT, ptysignaled);
	if ((pid = fork()) == -1) {
		fprintf(stderr, "No processes\n");
		return -1;
	}
	if (!pid) {
		close(STDIN_FILENO);
		close(STDOUT_FILENO);
		close(STDERR_FILENO);
		close(tfd);
		
		setsid();
		pty_name[5] = 't';
		if ((tfd = open(pty_name, O_RDWR)) < 0) {
			fprintf(stderr, "Child: Can't open pty %s\n", pty_name);
			exit(1);
		}
		dup2(tfd, STDIN_FILENO);
		dup2(tfd, STDOUT_FILENO);
		dup2(tfd, STDERR_FILENO);
		/*if(!(argv[0] = getenv("SHELL")))*/
			argv[0] = SHELL;
		argv[1] = NULL;
		execv(argv[0], argv);
		exit(1);
	}
	return tfd;
}

int
ReadPtyShell(int fd, char *buf, int count)
{
	return read(fd, buf, count);
}

int
WritePtyShell(int fd, char *buf, int count)
{
	return write(fd, buf, count);
}

void
ClosePtyShell(int fd)
{
	if(ttyfd != -1)
		close(fd);
}

volatile int	decoder_cc_enabled = 0;
volatile int	encoder_cc_enabled = 0;
unsigned char	encoder_cc_buf[ 64 ];
unsigned char	decoder_cc_screen[ 8 ][ 32 ];
unsigned char	decoder_cc_off_screen[ 8 ][ 32 ];

#define RAW_VBI_LEN		(720*10)

#define DEBUG_CC

#ifdef DEBUG_CC
FILE*	fcc = 0;
int curCCrow = 0;
#endif

int parse_cc( unsigned char cc1, unsigned char cc2 )
{  
	static unsigned char	offset = 0;
	static unsigned char	row = 0;
	static unsigned char	colidx = 0;
	int		update_screen = 0;
	
#ifdef DEBUG_CC
	fprintf(fcc,"[%2.2X %2.2X @%d] ",cc1,cc2,colidx);
#endif
	if( colidx >= 32 )
	{
		CCRollup(1);
#ifdef DEBUG_CC
		fprintf(fcc,">32\r\n");
#endif
	}
	
	cc1 &= 0x7F;
	cc2 &= 0x7F;
		
	//	check for row codes
	if( ( cc1 >= 0x11 ) && ( cc1 <= 0x14 ) && ( cc2 & 0x40 ) )
	{
		offset = ( cc2 & 0x20 ) ? 1 : 0;
		colidx = 0;
		switch( cc1 )
		{
			case 0x11:
				row = offset;
				break;
			case 0x12:
				row = offset + 2;
				break;
			case 0x13:
				row = offset + 4;
				break;
			case 0x14:
				row = offset + 6;
				break;
		}
#ifdef DEBUG_CC
		fprintf(fcc,"row+%d=%d\r\n",offset,row);
#endif
		return update_screen ;
	}
	
	if( ( cc1 != 0x11 ) && ( cc1 != 0x14 ) && ( cc1 != 0x17 ) )
	{
		//	regular data (text) byte
		if( cc1 )
		{
			if(gOSD)
				CCOutChar(cc1,row,colidx,TRUE);
			decoder_cc_off_screen[ row ][ colidx++ ] = (char)cc1;
#ifdef DEBUG_CC
		fprintf(fcc,"%c",cc1);
#endif
		}
		if( cc2 )
		{
			if(gOSD)
				CCOutChar(cc2,row,colidx,TRUE);
			decoder_cc_off_screen[ row ][ colidx++ ] = (char)cc2;
#ifdef DEBUG_CC
		fprintf(fcc,"%c\r\n",cc2);
#endif
		}
		return update_screen;
	}
	
	switch( cc1 )
	{
		case 0x11:
#ifdef DEBUG_CC
			//	attribute
			switch( cc2 )
			{
				case 0x20:
					fprintf(fcc,"<white>\r\n");//	white
					break;
				case 0x21:
					fprintf(fcc,"<white2>\r\n");//	white underline
					break;
				case 0x22:
					fprintf(fcc,"<green>\r\n");//	green
					break;
				case 0x23:
					fprintf(fcc,"<green2>\r\n");//	green underline
					break;
				case 0x24:
					fprintf(fcc,"<blue>\r\n");//	blue
					break;
				case 0x25:
					fprintf(fcc,"<blue2>\r\n");//	blue underline
					break;
				case 0x26:
					fprintf(fcc,"<cyan>\r\n");//	cyan
					break;
				case 0x27:
					fprintf(fcc,"<cyan2>\r\n");//	cyan underline
					break;
				case 0x28:
					fprintf(fcc,"<red>\r\n");//	red
					break;
				case 0x29:
					fprintf(fcc,"<red2>\r\n");//	red underline
					break;
				case 0x2A:
					fprintf(fcc,"<yellow>\r\n");//	yellow
					break;
				case 0x2B:
					fprintf(fcc,"<yellow2>\r\n");//	yellow underline
					break;
				case 0x2C:
					fprintf(fcc,"<magenta>\r\n");//	magenta
					break;
				case 0x2D:
					fprintf(fcc,"<magenta2>\r\n");//	magenta underline
					break;
				case 0x2E:
					fprintf(fcc,"<italics>\r\n");//	italics
					//decoder_cc_off_screen[ row ][ colidx++ ] = ' ';
					break;
				case 0x2F:
					fprintf(fcc,"<italics2>\r\n");//	italics underline
					break;
				default:
					fprintf(fcc,"<??>\r\n");//	
					break;
			}
#endif
			break;
		case 0x14:
			switch( cc2 )
			{
				case 0x20:
					memset(decoder_cc_off_screen,0,sizeof(decoder_cc_off_screen));
					/*for( i = 0; i < 32; i++ )
					{
						//	start of caption
						decoder_cc_off_screen[ 0 ][ i ] = 0x00;
						decoder_cc_off_screen[ 1 ][ i ] = 0x00;
						decoder_cc_off_screen[ 2 ][ i ] = 0x00;
						decoder_cc_off_screen[ 3 ][ i ] = 0x00;
						decoder_cc_off_screen[ 4 ][ i ] = 0x00;
						decoder_cc_off_screen[ 5 ][ i ] = 0x00;
						decoder_cc_off_screen[ 6 ][ i ] = 0x00;
						decoder_cc_off_screen[ 7 ][ i ] = 0x00;
					}*/
					//if(gOSD)
					//	CCOutChar(0,0,0,FALSE);
#ifdef DEBUG_CC
					fprintf(fcc," init mem\r\n");
#endif					
					break;
				case 0x21:
					//	backspace
					if(colidx)
						--colidx;
					if(gOSD)
						CCOutChar(0x08,row,colidx,FALSE);
#ifdef DEBUG_CC						
					fprintf(fcc," backspace\r\n");	
#endif					
					break;
				case 0x24:
					//	clear to the end of the line
					if(gOSD)
						CCOutChar('\r',row,colidx,FALSE);
#ifdef DEBUG_CC						
					fprintf(fcc," clear2end\r\n");
#endif					
					break;
				case 0x25:
					//	roll-up captions 2 rows
					if(gOSD)
						CCRollup(2);
#ifdef DEBUG_CC						
					fprintf(fcc," roll2\r\n");
#endif					
					break;
				case 0x26:
					//	roll-up captions 3 rows
					if(gOSD)
						CCRollup(3);
#ifdef DEBUG_CC						
					fprintf(fcc," roll3\r\n");
#endif					
					break;
				case 0x27:
					//	roll-up captions 4 rows
					if(gOSD)
						CCRollup(4);
#ifdef DEBUG_CC						
					fprintf(fcc," roll4\r\n");
#endif					
					break;
				case 0x28:
					//	flash on
#ifdef DEBUG_CC						
					fprintf(fcc," flashon\r\n");
#endif					
					break;
				case 0x29:
					//	resume direct captioning
#ifdef DEBUG_CC						
					fprintf(fcc," direct\r\n");
#endif					
					break;
				case 0x2A:
					//	text restart
#ifdef DEBUG_CC						
					fprintf(fcc," text restart\r\n");
#endif					
					break;
				case 0x2B:
					//	resume text display
#ifdef DEBUG_CC						
					fprintf(fcc," text display\r\n");
#endif					
					break;
				case 0x2C:
					update_screen = 1;
					memset(decoder_cc_screen,0,sizeof(decoder_cc_screen));
					/*for( i = 0; i < 32; i++ )
					{
						//	clear previous caption
						decoder_cc_screen[ 0 ][ i ] = 0x00;
						decoder_cc_screen[ 1 ][ i ] = 0x00;
						decoder_cc_screen[ 2 ][ i ] = 0x00;
						decoder_cc_screen[ 3 ][ i ] = 0x00;
						decoder_cc_screen[ 4 ][ i ] = 0x00;
						decoder_cc_screen[ 5 ][ i ] = 0x00;
						decoder_cc_screen[ 6 ][ i ] = 0x00;
						decoder_cc_screen[ 7 ][ i ] = 0x00;
					}*/
					if(gOSD)
					{
						++ClearCC; //non re-trigger
						//CCOutChar(0,0,0,FALSE);
#ifdef DEBUG_CC						
						fprintf(fcc," clear screen\r\n");
#endif						
					}
					break;
				case 0x2D:
					//	carriage return
#ifdef DEBUG_CC						
					fprintf(fcc," return\r\n");
#endif					
					break;
				case 0x2E:
					//	erase non-displayed memory
#ifdef DEBUG_CC						
					fprintf(fcc," erase\r\n");
#endif					
					break;
				case 0x2F:
					update_screen = 1;
					memcpy(decoder_cc_screen,decoder_cc_off_screen,sizeof(decoder_cc_screen));
					memset(decoder_cc_off_screen,0,sizeof(decoder_cc_off_screen));
					/*for( i = 0; i < 32; i++ )
					{
						//	display caption
						decoder_cc_screen[ 0 ][ i ] = decoder_cc_off_screen[ 0 ][ i ];
						decoder_cc_screen[ 1 ][ i ] = decoder_cc_off_screen[ 1 ][ i ];
						decoder_cc_screen[ 2 ][ i ] = decoder_cc_off_screen[ 2 ][ i ];
						decoder_cc_screen[ 3 ][ i ] = decoder_cc_off_screen[ 3 ][ i ];
						decoder_cc_screen[ 4 ][ i ] = decoder_cc_off_screen[ 4 ][ i ];
						decoder_cc_screen[ 5 ][ i ] = decoder_cc_off_screen[ 5 ][ i ];
						decoder_cc_screen[ 6 ][ i ] = decoder_cc_off_screen[ 6 ][ i ];
						decoder_cc_screen[ 7 ][ i ] = decoder_cc_off_screen[ 7 ][ i ];
					}*/

					/*for( y = 0; y < 8; y++)
					{
						for( x = 0; x < 32; x++)
						{
							
							c = decoder_cc_off_screen[y][x];
							decoder_cc_screen[y][x] = c;
							//if(c)
							//	CCOutChar(c,y,x);
						}
					}*/
#ifdef DEBUG_CC						
					fprintf(fcc," update\r\n");
#endif					
					break;
				default:
#ifdef DEBUG_CC						
					fprintf(fcc," ??\r\n");
#endif					
					break;
			}
			break;
		case 0x17:
			switch( cc2 )
			{
				case 0x21:
					//	tab offset 1 column
					colidx += 1;
#ifdef DEBUG_CC						
					fprintf(fcc," tab1\r\n");
#endif					
					break;
				case 0x22:
					//	tab offset 2 columns
					colidx += 2;
					colidx &= ~2;
#ifdef DEBUG_CC						
					fprintf(fcc," tab2\r\n");
#endif					
					break;
				case 0x23:
					//	tab offset 3 columns
					colidx += 3;
					colidx -= (colidx % 3);
#ifdef DEBUG_CC						
					fprintf(fcc," tab3\r\n");
#endif					
					break;
				default:
#ifdef DEBUG_CC						
					fprintf(fcc," ??\r\n");
#endif					
					break;
			}
			break;
	}
	return update_screen;
}


void render_cc()
{
	char		row_buf[ 34 ];
	char		tmp[ 256 ];
	int		i,n,m;
		
	/* render the rows */
	for( i = 0; i < 8; i++ )
	{
		memset( row_buf, 0, sizeof(row_buf) );
		strncpy( row_buf, (const char*)decoder_cc_screen[ i ], 32 );
		for(n = 0; n < 32; n++)
		{
			if( row_buf[n] == 0 )
			{
				row_buf[n] = ' ';
				continue;
			}
			sprintf(tmp, "%s\r\n", row_buf );
#ifdef DEBUG_CC
			fprintf(fcc,tmp);
#endif			
			StatusOutStr(tmp);
			
			//dump hex
			for(m=0;m<32;m++)
			{
				if(row_buf[m] == 0)
					break;
				sprintf(tmp,"%2.2X ",row_buf[m]);
				StatusOutStr(tmp);	
			}
			sprintf(tmp, "\r\n" );
#ifdef DEBUG_CC
			fprintf(fcc,tmp);
#endif			
			StatusOutStr(tmp);
			break;
		}
	}
}
void stopvbi()
{
	VIDEO_FORMAT	fmt;
	if(vbi >= 0)
	{
	
		memset( &fmt, 0, sizeof(fmt) );
		if( ioctl(vbi,VIDIOC_S_FMT,&fmt) < 0 )
		{
			StatusOutStr("stopvbi error\r\n");				
		}

		close(vbi);
		vbi = -1;
	}
}

int CheckCC()
{
	VIDEO_FORMAT	fmt;
	
	if(vbi < 0)
	{
		vbi = open( "/dev/vbi", O_RDONLY );
		if(vbi >= 0)
		{
			memset( &fmt, 0, sizeof(fmt) );
			fmt.fmt.vbi.sampling_rate = 60;
			fmt.fmt.vbi.offset = 9;             
			fmt.fmt.vbi.samples_per_line = 2;   
			fmt.fmt.vbi.sample_format = V4L2_VBI_SF_UBYTE;		
			fmt.fmt.vbi.start[0] = 20;
			fmt.fmt.vbi.start[1] = 283;
			fmt.fmt.vbi.count[0] = 1;
			fmt.fmt.vbi.count[1] = 1;
			fmt.fmt.vbi.flags = 0;
			if( ioctl(vbi,VIDIOC_S_FMT,&fmt) < 0 )
			{
				stopvbi();
				StatusOutStr("vbi error\r\n");				
			}
			else
			{
				StatusOutStr("Start close caption\r\n");
#ifdef DEBUG_CC
				fcc = fopen( "cc.txt", "w+" );
#endif				
			}
		}
	}
	if(vbi >= 0)
	{
		return decode_cc( vbi );
	}
	return 0;
}
int get_cc( )
{
	VIDEO_FORMAT	fmt;
	int i;
	int rc = 1;
	i = 20000UL;
	
	if(vbi < 0)
		vbi = open( "/dev/vbi", O_RDONLY );
	if( vbi == -1 )
	{
		StatusOutStr( "failed to open vbi\r\n" );
		return 0;
	}
	if( raw_mode )
	{
		FILE*	fraw = 0;
		fraw = fopen( "raw.txt", "w+" );
		if( fraw == NULL )
		{
			StatusOutStr("failed to open raw.txt\r\n");
			return 0;
		}
		
		memset( &fmt, 0, sizeof(fmt) );

		fmt.fmt.vbi.sampling_rate = 60;
		fmt.fmt.vbi.offset = 9;             
		fmt.fmt.vbi.samples_per_line = 720;   
		fmt.fmt.vbi.sample_format = V4L2_VBI_SF_UBYTE;		
		fmt.fmt.vbi.start[0] = 20;
		fmt.fmt.vbi.start[1] = 283;
		fmt.fmt.vbi.count[0] = 1;
		fmt.fmt.vbi.count[1] = 1;
		fmt.fmt.vbi.flags = 0;

		if( ioctl(vbi,VIDIOC_S_FMT,&fmt) < 0 )
		{
			StatusOutStr("failed to set format\r\n");
		}

		sleep( 1 );

		i = 10UL;
		do
		{
			rc = decode_raw( fraw, vbi );
				
		} while( i-- );
		//fclose( fraw );
	}
	
	stopvbi();
	StatusOutStr(".");
	return rc;
}
int decode_cc( int vbi ) 
{
	__u8	vbi_data[ 2 ];
	int	len;
	int rc = 0;

	vbi_data[0] = 0;
	vbi_data[1] = 0;
	len = read( vbi, vbi_data, 2 );
	
	if(len > 0)
	{
		if( ( vbi_data[0] != 0x00 ) && ( vbi_data[1] != 0x00 ) )
		{
			if( parse_cc( vbi_data[0], vbi_data[1] ) )
			{
				render_cc();
			}
			rc = 1;
		}
		else 
		{
			/*if(vbi_data[0])
					EmOutChar(gStatusHwnd,'0');
			else if(vbi_data[1])
					EmOutChar(gStatusHwnd,'1');
			else*/
					EmOutChar(gStatusHwnd,'+');
		}
				
	}
	//else EmOutChar(gStatusHwnd,'-');
	
	//clear cc after timeout
	if(ClearCC)
	{
	
		ClearCC += CC_INTERVAL;
		if(ClearCC > 5000)
		{
			ClearCC = 0;
			CCOutChar(0,0,0,FALSE);
		} 	
	}
	
	return rc;
}

int decode_raw( FILE* fp, int vbi ) 
{
	__u8	vbi_data[ RAW_VBI_LEN ];
	int	len;
	//int	vbi;
	//struct VIDEO_FORMAT fmt;
	char	tmp[128];
	int rc = 1;
	

	memset( &vbi_data, 0, sizeof(vbi_data) );
	len = read( vbi, vbi_data, RAW_VBI_LEN );
	
	if( len <= 0 )
	{
		//sprintf(tmp,"%d failed to read\r\n", len);
		//StatusOutStr(tmp);
	}
	else
	{
	
		int	i = 0;
		int	ii = 0;
		//StatusOutStr("//--------------- read ------------------//\r\n");
		
		for( i = 0; i < len; i += 16 )
		{
			unsigned char c = 0;
			for(ii = 0; ii < 16; ii++)
			{
				c |= vbi_data[i+ii];
			}
			if(c)
			{
				
				sprintf(tmp,"0x%04X: %02X %02X %02X %02X %02X %02X %02X %02X "
				" %02X %02X %02X %02X %02X %02X %02X %02X\r\n",
				i, vbi_data[i], vbi_data[i+1], vbi_data[i+2],
				vbi_data[i+3], vbi_data[i+4], vbi_data[i+5],
				vbi_data[i+6], vbi_data[i+7], vbi_data[i+8],
				vbi_data[i+9], vbi_data[i+10], vbi_data[i+11],
				vbi_data[i+12], vbi_data[i+13], vbi_data[i+14],
				vbi_data[i+15]);
				if(gUseFile)
					fprintf(fp,"%s",tmp);
				else
					StatusOutStr(tmp);
			}
		}
		sprintf(tmp,"len = %d\r\n",len);
		if(gUseFile)
			fprintf(fp,"%s",tmp);
		else
			StatusOutStr(tmp);
		//StatusOutStr(tmp);
		rc = 0;
	}
	return rc;
}

#if 0
/*
int test1()
{
	char			*device_video = "/dev/video";
	char			*device_vbi = "/dev/vbi";
	int			vid;
	int			vbi;
	int			err;
	int			i;
	struct CAPABILITY	cap;
        struct VIDEO_FORMAT	fmt;
	//char			*data;
	char			tmp[128];
	struct v4l2_input	vi;

	vid = open(device_video, O_RDONLY);
	if (vid < 0)
	{
		sprintf(tmp, "Can't open %s\r\n", device_video);
		StatusOutStr(tmp);
		return 1;
	}
	sprintf(tmp, "peter: opened %s successfully\r\n", device_video );
	StatusOutStr(tmp);
	
	vbi = open(device_vbi, O_RDONLY);
	if (vbi < 0)
	{
		sprintf(tmp, "Can't open %s\r\n", device_vbi);
		StatusOutStr(tmp);
		return 1;
	}
	sprintf(tmp, "peter: opened %s successfully\r\n", device_vbi );
	StatusOutStr(tmp);
	
	err = ioctl(vid, VIDIOC_QUERYCAP, &cap);
	if (err)
	{
		sprintf(tmp, "QUERYCAP returned error %d\r\n", errno);
		StatusOutStr(tmp);
		return 1;
	}
	if (cap.type != V4L2_TYPE_CAPTURE)
	{
		sprintf(tmp, "Device %s is not a video capture device.\r\n",
			device_video);
		StatusOutStr(tmp);
		return 1;
	}
	if (!(cap.flags & V4L2_FLAG_READ))
	{
		sprintf(tmp, "Device %s doesn't support read().\r\n", device_video);
		StatusOutStr(tmp);	
		return 1;
	}

	fmt.type = V4L2_BUF_TYPE_CAPTURE;
	err = ioctl(vid, VIDIOC_G_FMT, &fmt);
	if (err)
	{
		sprintf(tmp, "G_FMT returned error %d\r\n", errno);
		StatusOutStr(tmp);
		return 1;
	}
	
	for(i = 0; i < cap.inputs; i++)
	{
		vi.index = i;
		if (ioctl(vid, VIDIOC_ENUMINPUT, &vi) != 0)
			continue;
		sprintf(tmp, "input%d: %s\r\n", i,vi.name);
		StatusOutStr(tmp);	
	}

//<peter>
#if 0
//VBI data capture test
	data = malloc(fmt.fmt.pix.sizeimage);
	if (data == NULL)
	{
		sprintf(tmp, "malloc(%d) failed\r\n", fmt.fmt.pix.sizeimage);
		StatusOutStr(tmp);
		return 1;
	}

	n = read(vid, data, fmt.fmt.pix.sizeimage);
	if (n < 0)
	{
		sprintf(tmp, "read() returned error %d\r\n", errno);
		StatusOutStr(tmp);
		return 1;
	}
#endif
//</peter>

	stopvbi();
	close(vid);
#ifdef DEBUG_CC
	if(fcc)
		fclose(fcc);
	fcc = 0;
#endif
	return 0;
}
*/
#endif

int
vcat(/*int argc, char *argv[]*/)
{
	char			*device	= NULL;
	int			vid;
	int			err;
	int			i;
	int			n;
	VIDEO_CAPABILITY	cap;
        VIDEO_FORMAT	fmt;
	int			bgr	= 0; //1
	int			rgb	= 0; //1
	int			rgbswap	= 0;
	char			*data;
	char			t;
	char			tmp[128];


/*	for (i = 1; i < argc; ++i)
	{
		if (strcmp(argv[i], "-rgb") == 0)
			rgb = 1;
		else if (strcmp(argv[i], "-bgr") == 0)
			bgr = 1;
		else if (argv[i][0] == '-')
			continue;
		else
			device = argv[i];
	}*/
	if (device == NULL)
		device = "/dev/video";


	vid = open(device, O_RDONLY);
	if (vid < 0)
	{
		sprintf(tmp, "Can't open %s\r\n", device);
		StatusOutStr(tmp);
		return 1;
	}

	err = ioctl(vid, VIDIOC_QUERYCAP, &cap);
	if (err)
	{
		sprintf(tmp, "QUERYCAP returned error %d\r\n", errno);
		StatusOutStr(tmp);
		return 1;
	}
	if (cap.type != V4L2_TYPE_CAPTURE)
	{
		sprintf(tmp, "Device %s is not a video capture device.\r\n",
			device);
		StatusOutStr(tmp);
		return 1;
	}
	if (!(cap.flags & V4L2_FLAG_READ))
	{
		sprintf(tmp, "Device %s doesn't support read().\r\n", device);
		StatusOutStr(tmp);
		return 1;
	}


	fmt.type = V4L2_BUF_TYPE_CAPTURE;
	err = ioctl(vid, VIDIOC_G_FMT, &fmt);
	if (err)
	{
		sprintf(tmp, "G_FMT returned error %d\r\n", errno);
		StatusOutStr(tmp);
		return 1;
	}

	if ((fmt.fmt.pix.pixelformat == V4L2_PIX_FMT_RGB24 && bgr) ||
	    (fmt.fmt.pix.pixelformat == V4L2_PIX_FMT_BGR24 && rgb))
		rgbswap = 1;


	data = malloc(fmt.fmt.pix.sizeimage);
	if (data == NULL)
	{
		sprintf(tmp, "malloc(%d) failed\r\n", fmt.fmt.pix.sizeimage);
		StatusOutStr(tmp);
		return 1;
	}

	n = read(vid, data, fmt.fmt.pix.sizeimage);
	if (n < 0)
	{
		sprintf(tmp, "read() returned error %d\r\n", errno);
		StatusOutStr(tmp);
		return 1;
	}

	if (rgbswap)
		for (i = 0; i < n; i += 3)
		{
			t = data[i];
			data[i] = data[i + 2];
			data[i + 2] = t;
		}

	if (n)
		fwrite(data, (size_t)n, 1, stdout);

	return 0;
}

int gTimer2 = 0;
/*int AnimateClip(int delta)
{
//	char tmp[80];
//	gWidth += delta;
//	sprintf(tmp, "Width %d\r\n", gWidth);
//	StatusOutStr(tmp);
//	return SetVideoSize();	
	if(!gTimer2)
		gTimer2 = SetTimer(gHwnd, 2, 100, NULL); //WM_TIMER
	else
	{
		KillTimer(gHwnd,2);
		gTimer2 = 0;
	}
	return 0;	
}*/


/*int DemoClipping()
{
	static BOOL bExpanding = TRUE;
	char buf[100];
	FILE *fp;
	BOOL bChanged = FALSE;
	
	OVERLAY_INFO * pOverlayInfo;
	pOverlayInfo = (OVERLAY_INFO *)buf;

	fp=fopen("/dev/vout", "w");
	if(fp == NULL)
	{
		StatusOutStr("Cannot Open file /dev/vout\n");
		return 1;
	}
	
	pOverlayInfo->TypeOfData = 1;
	
	if(bExpanding)
	{
		if(gClipRect.left > gRect.left) { --gClipRect.left; bChanged=TRUE; }	
		if(gClipRect.right < gRect.right) { ++gClipRect.right; bChanged=TRUE; }	
		if(gClipRect.top > gRect.top) { --gClipRect.top; bChanged=TRUE; }	
		if(gClipRect.bottom < gRect.bottom) { ++gClipRect.bottom; bChanged=TRUE; }	
	}
	else
	{
		if(gClipRect.left < gClipRect.right) { ++gClipRect.left; bChanged=TRUE; }	
		if(gClipRect.right > gClipRect.left) { --gClipRect.right; bChanged=TRUE; }	
		if(gClipRect.top < gClipRect.bottom) { ++gClipRect.top; bChanged=TRUE; }	
		if(gClipRect.bottom > gClipRect.top) { --gClipRect.bottom; bChanged=TRUE; }	
	}
	if(!bChanged)
		bExpanding = !bExpanding;
	pOverlayInfo->StartX = gClipRect.left;
	pOverlayInfo->StartY = gClipRect.top;
        pOverlayInfo->Width = gClipRect.right - gClipRect.left;
	pOverlayInfo->Height = gClipRect.bottom - gClipRect.top;

	pOverlayInfo->BufferOffset = 0xF0000;
	pOverlayInfo->BufferWidth = 720;
	pOverlayInfo->BufferHeight = 480;
        		
	pOverlayInfo->VideoFormat = 0;
			
	pOverlayInfo->ColorKey = PETER_MAGENTA; //MAGENTA
	pOverlayInfo->ColorMask = 0x00F0F0F0;
	pOverlayInfo->Graphics = 1;
	
	pOverlayInfo->Enable = 1;
	

	fwrite(buf, 1, 64, fp);
	fclose(fp);

return 0;
}*/
int ChangeCCbground()
{
	gCCbg = !gCCbg;
	return 0;
}
int ChangeFullBlend()
{
	gFullBlend = !gFullBlend;
	return 0;
}
int SetLogo()
{
	HDC	hdc;
	//RECT	rc;
	//HBRUSH	gOvlBrush;
	//POINT p1 = {0,0};
	
	hdc = GetDC(gDisplayHwnd);
	GetClientRect(gDisplayHwnd, &gLogoRect);
	gLogoRect.left += 14;
	gLogoRect.top += 14;
	gLogoRect.right = gLogoRect.left + 239;
	gLogoRect.bottom = gLogoRect.top + 70;
	InvalidateRect(gDisplayHwnd,&gLogoRect,FALSE);
	if(!gLogo)
	{
		SetTimer(gDisplayHwnd,10, 10000, NULL);
		++gLogo;
	}
	else
	{
		KillTimer(gDisplayHwnd,10);
		gLogo = 0;
	}
	ReleaseDC(gDisplayHwnd, hdc);
	return 0;
}
int ChangeOSD()
{
	//int x,y;
	gOSD = !gOSD;
	ccCharWidth = ccCharWidth2;
	if(gOSD)
	{
		CCOutChar(0,0,0,FALSE); //erase the screen
		/*for(y = 0; y < CCROWS; y++)
		{
			for(x = 0; x < CCCOLS; x++)
			{
				CCOutChar('*',y,x,TRUE);
			}
		}*/
		SetTimer(gHwnd, CC_TIMER, CC_INTERVAL, NULL); //WM_TIMER	
	}
	else
	{
		KillTimer(gHwnd, CC_TIMER);
		if(vbi)
		{
			
			stopvbi();
		}
		CCOutChar(0,0,0,FALSE); //erase the screen
	}
	return 0;	
}

int FullScreen()
{

	RECT r;
	gSavedLogo = gLogo;
	GetWindowRect(GetDesktopWindow(), &r);
	
	if(gSavedLogo)
	{
		SetLogo();
	}
	if(!isFullScreen)
	{
		GetWindowRect(gHwnd,&mainRect);
		GetWindowRect(gDisplayHwnd,&displayRect);
		
		//set overlay to full screen first
		gOverlayW = gDecoderW = 720;
		gOverlayH = gDecoderH = 480;
		SetVideoSize(gDecoderW,gDecoderH);
		gOverlayX = gOverlayY = 0;
		SetOverLay(gOverlayX,gOverlayY,gOverlayW,gOverlayH);
		
		//do blending transition
		if(gFullBlend)
		{
			SetAlphaBlend(2,r,0,0x00FFFF,0,0); //decrement from FF opaque to tranparent
			Sleep(8000);
			
			//make all window borders outside of the screen
			r.left -= 3;
			r.right += 3;
			r.top -= 15;
			r.bottom += 3;
		}
		//cover the whole screen with the color key, so the alph2 can be deployed somewhere else
		MoveWindow(gHwnd,r.left,r.top,r.right - r.left,r.bottom - r.top,TRUE);
		MoveWindow(gDisplayHwnd,r.left,r.top,r.right - r.left,r.bottom - r.top,TRUE);
		
		//testing
		/*	r.left = 0;
			r.right = 360;
			r.top = 0;
			r.bottom = 240;
		SetAlphaBlend(2,r,0x01000000+GREEN,0x000080,0,0);
		*/
		if(gSavedLogo)
		{
			SetLogo();
		}
	}
	else
	{
		// before doing transition, put the alpha2 back inplace
		// any graphics will be invisible except supported by alpha0 or alpha1
		if(gFullBlend)
			SetAlphaBlend(2,r,0,0x000000,0,0);	
		
		//put windows back in place
		MoveWindow(gHwnd,mainRect.left,mainRect.top,mainRect.right - mainRect.left,mainRect.bottom - mainRect.top,TRUE);
		MoveWindow(gDisplayHwnd,gDisplayX,gDisplayY,gDisplayW,gDisplayH,TRUE);
		
		if(gFullBlend)
		{
			SetAlphaBlend(2,r,0,0x000100,0,0); //increment from 0 tranparent to opaque
			
			// need to lock up for 8 seconds if reuse alpha2
			//Sleep(8000);
			//ScaleToWindow();
			
			//user timer to call ScaleToWindow
			SetTimer(gDisplayHwnd,11, 10000, NULL); 
			
		}
		else
		{
			//restore overlay and logo state
			ScaleToWindow();
			if(gSavedLogo)
			{
				gSavedLogo = 0;
				SetLogo();
			}
		}
	}
	isFullScreen  = !isFullScreen;
	SetFocus(gDisplayHwnd);
	
	return 0;	
}

int Scaling(int wid, int height)
{
	if(gDecoderW == 720)
	{
		gOverlayW = gDecoderW = 360;
		gOverlayH = gDecoderH = 240;
		gOverlayX = gOverlayY = 0;
	}
	else
	{
		gOverlayW = gDecoderW = 720;
		gOverlayH = gDecoderH = 480;
		gOverlayX = gOverlayY = 0;
	}
	SetVideoSize(gDecoderW,gDecoderH);
	SetOverLay(gOverlayX,gOverlayY,gOverlayW,gOverlayH);
	return 0;
}

#if 0
typedef struct {
           int            TypeOfData;   // Is this data for Overlay or AlphaBlending or Palette
	                                // '1' for Overlay,'2' for Alpha and '3' for Palette data
           short          StartX;       // Start x coordinate of the Overlay window
           short          StartY;       // Start y coordinate of the Overlay window
	   unsigned short Width;        // Width of the Overlay window
	   unsigned short Height;       // Height of the Overlay window
	   unsigned long  BufferOffset; // Offset of the Start of Overlay buffer with
	                                // respect to start of Framebuffer.
	   unsigned short BufferWidth;  // Width of Overlay buffer in pixels.
	   unsigned short BufferHeight; // Height of Overlay buffer in pixels.
	   unsigned long  ColorKey;     // Colorkey to be used for Overlay.
	   unsigned long  ColorMask;    // Mask bits of the graphics or video stream being
	                                // compared to the Colorkey. This can be used to 
					// allow a range of values to be used as color key..
	   unsigned long  VideoFormat;  // Format of Overlay data : YUYV or 
	   int            Graphics;     // If '0' Video hardware will compare graphics data
	                                // to colorkey. If '1' Video data will be compared.
	   int            Enable;       // '0' for disable Overlay & '1' for enable.
} OVERLAY_INFO;
#endif

int ScaleToWindow()
{
	char tmp[80];
	int width = 720;
	int height = 480;
	RECT rc; 
	POINT p1 = {0,0};
	ClientToScreen(gDisplayHwnd,&p1);
	GetClientRect(gDisplayHwnd, &rc);
	if(gEnableScaling)
	{
		width = (rc.right - rc.left + 1) & ~1;
		height = rc.bottom - rc.top;
	}
	gOverlayW = gDecoderW = width;
	gOverlayH = gDecoderH = height;
	gOverlayX = rc.left+p1.x;
	gOverlayY = rc.top+p1.y;
	SetVideoSize(gDecoderW,gDecoderH);
	SetOverLay(gOverlayX, gOverlayY, gOverlayW, gOverlayH);
	
	sprintf(tmp,"w=%d h=%d\r\n",width,height);
	StatusOutStr(tmp);
	return 0;
}
int SetOverLay(int x, int y, int wid, int height)
{
	int rc = 0;
	int buf[100];
	int vout = 0;
	
	OVERLAY_INFO * pOverlayInfo;
	pOverlayInfo = (OVERLAY_INFO *)buf;
		
	vout=open("/dev/vout", O_WRONLY);
	if(vout < 0)
	{
		StatusOutStr("Cannot Open file /dev/vout\r\n");
		return 1;
	}
	
	if(gDisplayHwnd)
	{
		GetWindowRect(gDisplayHwnd, &gRect);
		
	}
	gClipRect = gRect;
	pOverlayInfo->TypeOfData = gEnableScaling;

	pOverlayInfo->StartX = x; //gRect.left; 0x08
	pOverlayInfo->StartY = y; //gRect.top; 0x0C
        pOverlayInfo->Width = wid; //gRect.right - gRect.left; 0x10
	pOverlayInfo->Height = height; //gRect.bottom - gRect.top; 0x14

	pOverlayInfo->BufferOffset = gBufferOffset; //0xF0800; //0x8320
	pOverlayInfo->BufferWidth = wid; //0x0 080068C3
	pOverlayInfo->BufferHeight = height; //0x
        		
	pOverlayInfo->VideoFormat = 0;
			
	pOverlayInfo->ColorKey = PETER_MAGENTA; //MAGENTA
	pOverlayInfo->ColorMask = 0x00F0F0F0;
	pOverlayInfo->Graphics = 1;
	
	pOverlayInfo->Enable = 1;
	

	rc = ioctl( vout, GEODE_IOCTL_SET_OVERLAY_INFO, pOverlayInfo );

	if(rc < 0)
	{
		IOCTL_Error("Error: GEODE_IOCTL_SET_OVERLAY_INFO", rc);
	}
	//write( vout, (char*)buf, sizeof(OVERLAY_INFO) );
#if 0		
	buf[0] = 0;
	buf[1] = 0x28;
	buf[2] = 0x1001;
	write( vout, (char*)buf, sizeof(OVERLAY_INFO) );
	
	buf[0] = 0;
	buf[1] = 0x4C;
	buf[2] = 0x60400;
	write( vout, (char*)buf, sizeof(OVERLAY_INFO) );
	
	//buf[0] = 0;
	//buf[1] = 0x8328;
	//buf[2] = 0x200082A2;
	//write( vout, (char*)buf, sizeof(OVERLAY_INFO) );
#endif	
			
	close(vout);

return rc;
}

/*typedef struct alpha_blend_info
{
	int            TypeOfData;   // Is this data for Overlay or AlphaBlending or Palette
					  // '1' for Overlay,'2' for Alpha and '3' for Palette data
	int            WindowNumber; // The Alpha Window to be used. Can be '0' '1' or '2'  
	int            Priority;     //
	unsigned short StartX;       // Start x coordinate of Alpha window
	unsigned short StartY;       // Start y coordinate of Alpha window
	unsigned short Width;        // Width of Alpha window
	unsigned short Height;       // Height of Alpha window
	unsigned char  Alpha;        // Alpha Value
	char           Delta;        // Value by which Alpha is Icremented at every frame.
	unsigned long  Color;        // If bit-24 is set, then display this color in the
					  // Alpha window when there is a color key match.
	int            Enable;       // '0' for disable Alpha Window & '1' for enable
} alpha_blend_info_t;*/

int GetRand(int mod)
{
    return rand() % mod;
}

int encoder_enable()
{
#if 0
static BOOL gStreamOn = FALSE;
	int rc = 0;
	int vout = 0;
	alpha_blend_info_t buf;
	
	vout=open("/dev/vout", O_WRONLY);
	if(vout <= 0)
		IOCTL_Error("Error:cannot open vout", rc);
	else
	{
		if(gStreamOn) gStreamOn = FALSE;
		else gStreamOn = TRUE; 
		rc = ioctl( vout, gStreamOn ? GEODE_IOCTL_STREAMON:GEODE_IOCTL_STREAMOFF, &buf );

		if(rc < 0)
		{
			IOCTL_Error("Error: VIDIOC_STREAMON/VIDIOC_STREAMOFF", rc);
		}
		else if(gStreamOn)
		{
			StatusOutStr("Stream on\r\n");
		}
		else
		{
			StatusOutStr("Stream off\r\n");
		}
		close(vout);
	}
#endif	
	return 0;
}

int ChangeField()
{
#if 0
	int rc = 0;
	int vout = 0;
	
	vout=open("/dev/vout", O_WRONLY);
	if(vout <= 0)
		IOCTL_Error("Error:cannot open vout", rc);
	else
	{
		rc = ioctl( vout,GEODE_IOCTL_FIELDS, 0 );

		if(rc < 0)
		{
			IOCTL_Error("Error: GEODE_IOCTL_FIELDS", rc);
		}
		close(vout);
	}
#endif
	return 0;

}
/*int AlphaTest(int wid, int height)
{
static int timer_id = 0;
    if(!timer_id)
    {
	DemoAlphaBlend();
	timer_id = SetTimer(gHwnd,3,2000,NULL);
    }
    else
    {
	KillTimer(gHwnd,timer_id);
	timer_id = 0;
    }
    return 0;
}*/

int SetAlphaBlend(int wnum,RECT rc,int subcolor,int alphaval,int xoffs,int yoffs)
{

	int iRet = 0;
	int buf[100];
	int vout = 0;
	alpha_blend_info_t * pOverlayInfo;
	//unsigned int alphaBaseAddr;
	int xbase = 0x26 + xoffs;
	int ybase = 0x22 + yoffs;	

	vout=open("/dev/vout", O_WRONLY);
	if(vout < 0)
	{
		StatusOutStr("Cannot Open file /dev/vout\n");
		return 1;
	}
	//alphaBaseAddr = 0x60;
	//if(wnum < 3);
	//    alphaBaseAddr += (wnum*0x10);

	//buf[0] = 0;
	//buf[1] = alphaBaseAddr;
	//buf[2] = ((rc.right+xbase)<<16)+(rc.left+xbase);
	//write( vout, (char*)buf, sizeof(OVERLAY_INFO) );
	//buf[0] = 0;
	//buf[1] = alphaBaseAddr+4;
	//buf[2] = ((rc.bottom+ybase)<<16)+(rc.top+ybase);
	//write( vout, (char*)buf, sizeof(OVERLAY_INFO) );
	//buf[0] = 0;
	//buf[1] = alphaBaseAddr+8;
	//buf[2] = subcolor;
	//write( vout, (char*)buf, sizeof(OVERLAY_INFO) );
	//buf[0] = 0;
	//buf[1] = alphaBaseAddr+12;
	//buf[2] = (alphaval < 0) ? 0 : (alphaval + 0x00030000);
	//write( vout, (char*)buf, sizeof(OVERLAY_INFO) );
	pOverlayInfo = (alpha_blend_info_t *)buf;
	pOverlayInfo->TypeOfData = 2;
	pOverlayInfo->Priority = wnum;
	pOverlayInfo->WindowNumber =wnum;
	
	pOverlayInfo->StartX = (rc.left+xbase);
	pOverlayInfo->StartY = (rc.top+ybase); 
        pOverlayInfo->Width = rc.right - rc.left; 
	pOverlayInfo->Height = rc.bottom - rc.top;
	pOverlayInfo->Alpha = alphaval & 0xFF; 
	pOverlayInfo->Delta = (alphaval >> 8) & 0xFF; 
	pOverlayInfo->Color = subcolor;       		
	pOverlayInfo->Enable = (alphaval < 0) ? 0 : 1;
	//fwrite(buf, 1, 64, fp);
	//write( vout, (char*)buf, sizeof(alpha_blend_info_t) );
	iRet = ioctl( vout, GEODE_IOCTL_SET_ALPHA_BLEND_INFO, pOverlayInfo );

	if(iRet < 0)
	{
		IOCTL_Error("Error: GEODE_IOCTL_SET_ALPHA_BLEND_INFO %d", iRet);
	}
	close(vout);
	return iRet;
}

/*int DemoAlphaBlend()
{
	RECT rc;    
	int wnum = GetRand(3);
	int subcolor = GetRand(0x2000000);
	int alphaval = GetRand(512);
	rc.right = GetRand(600)+40;
	rc.bottom = GetRand(440)+40;
	rc.left = GetRand(rc.right-39);
	rc.top = GetRand(rc.bottom-39);
	if(alphaval & 0x100)
	{
	    if(alphaval & 0x80)
		alphaval = 0x00FFFF;
	    else
		alphaval = 0x000100;
	
	}
	return SetAlphaBlend(wnum,rc,subcolor,alphaval,0,0);
}*/

//typedef int BOOL;
#define TRUE 1
#define FALSE 0
//#define _DEFINE_FMP_TYPES_
#include "../../../../NetStream2000-0.2.044.0/include/fmp.h"  

#if 1

void
PlayMpeg(int cmd)
{
static int fileIndex = 3;
#if 0
	//
	
	FMP_OPENSTRUCT FMPOpenStruct;
	if(cmd != 1) return;
	MPEGDriverEntry(NO_DRIVE);
			FMPOpenStruct.dwStructSize		= sizeof (FMP_OPENSTRUCT);
			FMPOpenStruct.bDriverNumber		= NO_DRIVE;
			FMPOpenStruct.dwSize			= 64*1024;
#if 1
			FMPOpenStruct.dwCount			= 10;
			FMPOpenStruct.pCallback			= NULL;
#else
			FMPOpenStruct.dwCount			= 10;
			FMPOpenStruct.pCallback			= Event_Notifications;
#endif
			FMPOpenStruct.dwContext			= 0;
			FMPOpenStruct.sFileName			= "/cygnus/sigma/bravhart.pes";
			FMPOpenStruct.dwFlags			= FMPF_SYSTEM;
			FMPOpenStruct.bDiscContent		= FMPC_UNKNOWN;
			FMPOpenStruct.bFileSystem		= 0; //SYS_ACCESS;
	FMPOpenDiscPlayback (&FMPOpenStruct);
		FMPEnableFullScreen(1);
		FMPSet (FMPI_MUTE, 0);
			
		FMPPlay();

#else
	//char tmp[256];
	//char* str;
	static int fd = -1;
	int streamtype;
	int bytesread=1,rc = FMPE_OK;
	int rdcount;
	int realmagic;
	
	switch(cmd)
	{
	case 0: //stop
		rc=FMPE_OK;
		KillTimer(gHwnd, MPEG_TIMER);
		//FMPFlush(1);
		//Sleep(200);
		//FMPPause();
		//Sleep(200);
		FMPStop();
		//Sleep(200);
		FMPClose();
		//Sleep(200);
		MPEGDriverUnload();
		close (fd);
		fd = -1;
		mpegPlaying = 0;
		break;
	case 1: //start
		rc=FMPE_OK;

		realmagic = open( "/dev/realmagic", O_RDONLY );
		if(realmagic < 0)
		{
			printf("failed to open realmagic\r\n");
			PostMessage(gHwnd, WM_CLOSE, 0, 0);
			break;
		}
		close(realmagic);
		//case 'p':
			/*if(ttyfd >= 0)
			{
				str = "cd /cygnus/sigma/NetStream2000-0.1.033.0\r\n";
				WritePtyShell(ttyfd, str, strlen(str));
				str = "./loaddriver\r\n";
				WritePtyShell(ttyfd, str, strlen(str));
				str = "cd /usr/iaconsui\r\n";
				WritePtyShell(ttyfd, str, strlen(str));
				Sleep(1000);
			}*/
		switch(fileIndex)
		{
		default:
			streamtype=FMPF_SYSTEM; //FMPF_TRANSPORT;
			MPEGDriverEntry(NO_DRIVE);
			FMPOpen(streamtype,64*1024,10,NULL,0); //64
			FMPSet (FMPI_MUTE, 0);
			FMPPlay();
			//fd=open("/cygnus/sigma/BRAVHART.MPG",O_RDONLY);
			fd=open("/cygnus/sigma/opera9.mpg",O_RDONLY);
			fileIndex = 2;
			break;
		case 1:		
			streamtype=FMPF_DVD;
			MPEGDriverEntry(NO_DRIVE);
			FMPOpen(streamtype,64*1024,10,NULL,0); //64
			FMPSet (FMPI_MUTE, 0);
			FMPPlay();
			//fd=open("/cygnus/sigma/VTS_01_1.VOB",O_RDONLY);
			fd=open("/cygnus/sigma/bean_01_1.vob",O_RDONLY);
			fileIndex = 3;
			break;
		case 2:
			streamtype=FMPF_TRANSPORT;
			MPEGDriverEntry(NO_DRIVE); 
			FMPOpen(streamtype,64*1024,10,NULL,0); //64
			FMPSet (FMPI_MUTE, 0);
			FMPPlay();
			fd=open("/cygnus/sigma/BRAVHART.MPG",O_RDONLY);
			//fd=open("/cygnus/sigma/opera1.mpg",O_RDONLY);
			fileIndex = 2;
			break;
		case 3:
			streamtype=FMPF_SYSTEM;
			MPEGDriverEntry(NO_DRIVE);
			FMPOpen(streamtype,64*1024,10,NULL,0); //64
			FMPSet (FMPI_MUTE, 0);
			FMPPlay();
			fd=open("/cygnus/sigma/opera1.mpg",O_RDONLY);
			fileIndex = 3;
			break;
		}
		if (fd<0) 
		{
			StatusOutStr("could not open file to play\r\n"); 
			break;
		} 
		SetTimer(gHwnd, MPEG_TIMER, MPEG_INTERVAL, NULL); //WM_TIMER
		mpegPlaying = 1;
		
		break;
	
	case 2: //update
		for(rdcount = 0; rdcount < 10 && rc==FMPE_OK; rdcount++) 
		{
			if(bytesread) 
			{
				FMP_BUFFER FMPBuf;
				//static int count=0;
			
				// get a pointer to a free buffer
				rc = FMPGetBuffer (&FMPBuf, FALSE);
				if (rc != FMPE_OK)
				{
					//sprintf (tmp,"FMPError : %s\n", FMPGetLastError(rc));
					//StatusOutStr(tmp);
					return;
				}	
			
				// signals can cause harmless EINTR
				while (((bytesread=read(fd,FMPBuf.pBuffer,FMPBuf.dwBufferSize)) == -1)
					&&(errno==EINTR));
				
				if (bytesread <= 0 /* -1*/) 
					bytesread=0;
				
				FMPBuf.dwDataSize = bytesread;
			
				// the buffer is ready to be queued
				FMPPush (&FMPBuf);
				
				//count++;			
			}
			if(!bytesread)
			{
				lseek (fd,0,SEEK_SET);
				bytesread=1;
			}
		}
		break;
	}
	return;
	
#endif	
}
#endif



/* ==================== DEBUG UTILS ====================== */
int Pan( int adj)
{
	if(adj)
		gBufferOffset += adj*16;
	else
		gBufferOffset = 0xF0800;
	gOverlayW = 720;
	gOverlayH = 480;
	gOverlayX = gOverlayY = 0;
	SetOverLay(gOverlayX, gOverlayY, gOverlayW, gOverlayH);
	return 0;
}


int DebugDump()
{
#if 0
	static unsigned char dec_buffer[256];
	static int init=0;
	diagnostic_info_t diag_info;
	int subaddr,i;
	int vout = -1;
	int width = 720;
	int height = 480;
	
	FILE* fd = fopen("dump.txt", "w+");
	RECT rc; 
	POINT p1 = {0,0};
	ClientToScreen(gDisplayHwnd,&p1);
	GetClientRect(gDisplayHwnd, &rc);
	width = (rc.right - rc.left + 1) & ~1;
	height = rc.bottom - rc.top;
	
	fprintf(fd,"w=%d h=%d\r\n",width,height);
	
	vout=open("/dev/vout", O_WRONLY);
	if(vout < 0)
	{
		fprintf(fd," -- Cannot Open file /dev/vout\r\n");
	}
	else
	{
		fprintf(fd,"=================================%d\r\n",init);
		for(subaddr = 0; subaddr < 256; subaddr++)
		{
			diag_info.cmd = READ_DEC;
			diag_info.arg1 = subaddr;
			diag_info.arg2 = 1; //minimum count
			if(0 > ioctl(vout, GEODE_IOCTL_DIAG, &diag_info))
			{
				fprintf(fd," -- ioctl error\r\n");
				break;
			}
			if(init)
			{
				if(dec_buffer[subaddr] != diag_info.result[0])
				{
					fprintf(fd,"%2.2X: %2.2X -> %2.2X\r\n", subaddr,dec_buffer[subaddr],diag_info.result[0]);	
				
				}
			}
			dec_buffer[subaddr] = diag_info.result[0];		
		}
		++init;
		close(vout);
	}
	
	
	for(subaddr = 0; subaddr < 256; subaddr+=16)
	{
		fprintf(fd,"%2.2X:", subaddr);
		for(i = 0; i < 16; i++)
		{
				fprintf(fd," %2.2X",dec_buffer[subaddr+i]);
		}
		fprintf(fd,"\r\n");
	}
	
	fclose(fd);
#endif
	return 0;
}

#ifdef NEW_VTEST

LRESULT CALLBACK
MainWndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp) //MAINCLASS
{
	PAINTSTRUCT	ps;
	HDC		hdc;
	RECT		rc;
	//static int	testcount = 0;
	BOOL bButtonClick = HIWORD(wp) == BN_CLICKED;
	//char	tmpstr[80];
	HWND	itemhwnd;
	int	x,y;
	
	switch( msg) {
	/*case WM_KEYDOWN:
	case WM_CHAR:
	{	
            int id = LOWORD(wp);
            int i;
		
	    itemhwnd = GetDlgItem(hwnd,id);

	    switch(id)
	    {
	    case IDC_CH:
	    	++i;
	    	break;
	    
	    case IDC_STATUS:
	    	++i;
	    	break;
	    }
	    return DefWindowProc( hwnd, msg, wp, lp);
	    break;
	}*/
	case WM_COMMAND:
        if(bButtonClick )
	{
            int id = LOWORD(wp);
	    	
	    itemhwnd = GetDlgItem(hwnd,id);

	    switch(id)
	    {
	    case IDC_CH_UP:
	    	SetChannel(gChNum+1);
		StatusOutStr("Channel Up\r\n");
		break;
	    case IDC_CH_DOWN:
	    	SetChannel(gChNum-1);
		StatusOutStr("Channel Down\r\n");
		break;
	    case IDC_VIDEO:
	    	EnableChItems(SW_HIDE,1);
		StatusOutStr("Select Video\r\n");
	    	break;
	    case IDC_SVIDEO:
	    	EnableChItems(SW_HIDE,2);
		StatusOutStr("Select SVideo\r\n");
	    	break;
	    case IDC_DIGITAL:
	    	EnableChItems(SW_HIDE,3);
		StatusOutStr("Select Digital Video\r\n");
	    	break;
	    case IDC_TUNER:
	    	EnableChItems(SW_SHOW,0);
		StatusOutStr("Select Tuner\r\n");
	    	break;
	    case IDC_MODE1: StatusOutStr("Select mode1\r\n"); break;
	    case IDC_MODE2: StatusOutStr("Select mode2\r\n"); break;
	    case IDC_MODE3: StatusOutStr("Select mode4\r\n"); break;
	    case IDC_MODE4: StatusOutStr("Select mode4\r\n"); break;
	    case IDC_MODE5: StatusOutStr("Select mode5\r\n"); break;
	    case IDC_MODE6: StatusOutStr("Select mode6\r\n"); break;
	    case IDC_MODE7: Pan(-1); break;
	    case IDC_MODE8: Pan(0); break;
	    case IDC_MODE9: Pan(1); break;

	    case IDC_OPTION1:
	    	{
			SetRawMode(SendMessage(itemhwnd,BM_GETCHECK,0,0));
			break;
		}
	    case IDC_OPTION2: gUseFile = SendMessage(itemhwnd,BM_GETCHECK,0,0) ; break;
	    case IDC_OPTION3: ChangeOSD(); break;
	    case IDC_OPTION4: SetAudio(currentselection,muting=0,1); break;
	    case IDC_OPTION5: SetAudio(currentselection,muting=0,-1); break;
	    case IDC_OPTION6: ChangeCCbground(); break;
	    case IDC_OPTION7: SetAudio(currentselection,SendMessage(itemhwnd,BM_GETCHECK,0,0),0); break;

	    case IDC_OPTION8: SetLogo(); break;
	    case IDC_OPTION9: gEnableScaling = SendMessage(itemhwnd,BM_GETCHECK,0,0); break; //ChangeFullBlend(); 
	    
	    case IDC_CMD1: OpenVideo(); break;
	    case IDC_CMD2: CloseVideo(); break;
	    case IDC_CMD3: get_cc(); break;
	    case IDC_CMD4: SetAudio(currentselection,muting,0); break; //test1();
	    case IDC_CMD5: ChangeField(); break; //Scaling(360,240); 
	    case IDC_CMD6: gFullBlend = 0; FullScreen(); break;
	    case IDC_CMD7: DebugDump(); break;  
	    case IDC_CMD8: encoder_enable(); break;	//AlphaTest(100,200); 
	    case IDC_CMD9: gFullBlend = 1; FullScreen(); break; //AnimateClip(1); 
	    default:
            	/*if (id == IDC_CHECK1 && HIWORD(wp) == BN_CLICKED)
	    	{
                	SetFocus(hwnd);
			PostMessage(itemhwnd, WM_CLOSE, 0, 0);
	    	}
	    	else*/
	    	{
	    		return DefWindowProc( hwnd, msg, wp, lp);
	    	}
		break;
	    } // switch
        }
	else
	{
		return DefWindowProc( hwnd, msg, wp, lp);
	}
		break;	
	//case WM_NCLBUTTONDOWN:
	//	++testcount;
	//	break;
	case WM_TIMER:
		if(wp == CC_TIMER && !raw_mode)
		{
			while(CheckCC())
			{
				//Sleep(10);
				//empty the cc buffer
			}
		}
		else if(wp == MPEG_TIMER )
		{
			PlayMpeg(2);
		}
		/*else if(wp == 2)
		{
			DemoClipping();
		}*/
		/*else if(wp == 3)
		{
			DemoAlphaBlend();
		}*/
		/*
		else if( wp == 10)
		{
			if(gLogo & 1)
				SetAlphaBlend(1,gAlphaRect,0,0x00FFFF,0,0); //opaque to transparent
			else
			{
				SetAlphaBlend(1,gAlphaRect,0,0x000100,0,0); //transparent to opaque
			}
			++gLogo;
		}
		*/
		break;
	//case WM_DESTROY:
	case WM_CLOSE:
	//case WM_QUIT:
	
		KillTimer(gHwnd, 1);
		if(mpegPlaying)
			PlayMpeg(0);
		
		gOverlayW = 720;
		gOverlayH = 480;
		gOverlayX = gOverlayY = 0;
		SetOverLay(gOverlayX, gOverlayY, gOverlayW, gOverlayH);
		if(vbi >= 0)
			close(vbi);
		//if(vid >= 0)
		//	close(vid);
		
		
//		VMW_AVS_VideoClose();

		PostQuitMessage(0);
		break;
#if TIMERDEMO
	case WM_CREATE:
		SetTimer(hwnd, 1, 100, NULL);
		mousept.x = 60;
		mousept.y = 20;
		break;

	case WM_TIMER:
//		KillTimer(gHwnd,1);
//		PostMessage(gHwnd,WM_COMMAND,(BN_CLICKED<<16)+IDC_CMD3,0);
#if 0
#if GRAPH3D
		GetClientRect(hwnd, &rc);
		if(countup) {
			mousept.y += 20;
			if(mousept.y >= rc.bottom) {
				mousept.y -= 20;
				countup = 0;
			}
		} else {
			mousept.y -= 20;
			if(mousept.y < 20) {
				mousept.y += 20;
				countup = 1;
			}
		}
		SendMessage(hwnd, WM_MOUSEMOVE, 0,
			MAKELONG(mousept.x, mousept.y));
#endif
#if ARCDEMO
		startdegrees += 10;
		if(startdegrees >= 360)
			startdegrees = 0;
		enddegrees += 15;
		if(enddegrees >= 360)
			enddegrees = 0;
		InvalidateRect(hwnd, NULL, TRUE);
#endif
#endif
		break;

#endif /* TIMERDEMO*/
	case WM_SIZE:
		break;

	case WM_MOVE:
		break;

#if CLIENT3D
	case WM_SETFOCUS:
		PostMessage((HWND)wp, WM_PAINT, 0, 0L);
		break;

	case WM_KILLFOCUS:
		PostMessage((HWND)wp, WM_PAINT, 0, 0L);
		break;
	case WM_ERASEBKGND:
		if(GetFocus() != hwnd)
			return DefWindowProc(hwnd, msg, wp, lp);
		return 1;
#endif
#if GRAPH3D
	case WM_ERASEBKGND:
		if((GetWindowLong(hwnd, GWL_ID) & 03) == 1)
			return 1;
		return DefWindowProc(hwnd, msg, wp, lp);
#endif
	case WM_PAINT:
		hdc = BeginPaint(hwnd, &ps);

#if CLIENT3D
		if(GetFocus() == hwnd) {
			GetClientRect(hwnd, &rc);
			Draw3dShadow(hdc, rc.left, rc.top,
				rc.right-rc.left, rc.bottom-rc.top,
				GetSysColor(COLOR_3DDKSHADOW),
				GetSysColor(COLOR_3DLIGHT));
			InflateRect(&rc, -1, -1);
			FillRect(hdc, &rc, GetStockObject(GRAY_BRUSH));
		}
#endif
#if IMAGE
		GetClientRect(hwnd, &rc);
		DrawDIB(hdc, rc.left+2, rc.top+2, image2);
#endif
#if ARCDEMO
{
	int x, y, w, h;
	RECT rc;

	if(hdc != NULL) {
		GetWindowRect(hwnd, &rc);
		rc.top += 13;
		InflateRect(&rc, -3, -3);
		//Ellipse(hdc, 0, 0, rc.right-rc.left, rc.bottom-rc.top);
		//Arc(hdc, 0, 0, rc.right-rc.left, rc.bottom-rc.top, 0,0, 0,0);
		//Pie(hdc, 0, 0, rc.right-rc.left, rc.bottom-rc.top, 0,0, 0,0);
#if 1
		x = rc.left;
		y = rc.top;
		w = rc.right - rc.left;
		h = rc.bottom - rc.top;
		w += 10;
		GdSetForeground(GdFindColor(RGB(0,255,0)));
		GdArcAngle(hdc->psd, x+w/2, y+h/2, w/2, h/2, startdegrees*64,
			enddegrees*64, MWPIE);
		GdSetForeground(GdFindColor(RGB(0,0,0)));
		GdArcAngle(hdc->psd, x+w/2, y+h/2, w/2, h/2, startdegrees*64,
			enddegrees*64, MWARCOUTLINE);
		//GdSetForeground(GdFindColor(RGB(255,255,255)));
		//GdPoint(hdc->psd, x+w/2, y+h/2);
#endif
	}
	EndPaint(hwnd, &ps);
	break;
}
#endif /* ARCDEMO*/
#if GRAPH3D
		id = (int)GetWindowLong(hwnd, GWL_ID) & 03;
		init3(hdc, id == 1? hwnd: NULL);
		switch(id) {
		case 0:
			rose(1.0, 7, 13);
			break;
		case 1:
			//look3(0.5, 0.7, 1.5);
			//look3(0.2, -2 * gy, 1.0+gx);
			look3(-2 * gx, -2 * gy, 1.2);
			drawgrid(-8.0, 8.0, 10, -8.0, 8.0, 10);
			break;
		case 2:
			setcolor3(BLACK);
			circle3(1.0);
			break;
		case 3:
			setcolor3(BLUE);
			daisy(1.0, 20);
			break;
		}

#if CLIPDEMO
		if(id == 1) {
			HRGN	hrgn, hrgn2;

			/* create circular clip region for effect*/
			GetClientRect(hwnd, &rc);
			InflateRect(&rc, -80, -80);
			switch((int)GetWindowLong(hwnd, GWL_ID)) {
			default:
				hrgn = CreateEllipticRgnIndirect(&rc);
				break;
			case 5:
				hrgn = CreateRoundRectRgn(rc.left, rc.top,
					rc.right, rc.bottom, 100, 100);
				break;
			case 1:
				hrgn = CreateRectRgnIndirect(&rc);
				break;
			}

			/* erase background, clip out blit area*/
			GetClientRect(hwnd, &rc);
			hrgn2 = CreateRectRgnIndirect(&rc);
			SelectClipRgn(hdc, hrgn2);
			ExtSelectClipRgn(hdc, hrgn, RGN_XOR);
			DeleteObject(hrgn2);

			GetClientRect(hwnd, &rc);
			FillRect(hdc, &rc, GetStockObject(BLACK_BRUSH));

			/* clip in only blit area*/
			SelectClipRgn(hdc, hrgn);
			DeleteObject(hrgn);
		}
#endif /* CLIPDEMO*/

		paint3(hdc);

#endif /* GRAPH3D*/
		EndPaint(hwnd, &ps);
		break;

	case WM_LBUTTONDOWN:
		break;

	case WM_MOUSEMOVE:
#if GRAPH3D
		if((GetWindowLong(hwnd, GWL_ID) & 03) == 1) {
			POINT pt;

			POINTSTOPOINT(pt, lp);
			GetClientRect(hwnd, &rc);
			gx = (vec1)pt.x / rc.right;
			gy = (vec1)pt.y / rc.bottom;
			InvalidateRect(hwnd, NULL, FALSE);
			mousept.x = pt.x;
			mousept.y = pt.y;
		}
#endif
		break;

	case WM_LBUTTONUP:
		break;

	case WM_RBUTTONDOWN:
		break;

	default:
		return DefWindowProc( hwnd, msg, wp, lp);
	}
	return( 0);
}

#endif //NEW_VTEST
