#include "objects.h"
#include "NX.h"

//static int in_popup = 0;

/**********************/
/* Callback functions */
/**********************/

void new_game_cb (GR_WINDOW_ID w) {
	game.start(1);
}

void quit_game_cb (GR_WINDOW_ID w) {
	game.quit();
}

void get_coords (GR_EVENT *event, int *x, int *y) {

  
	*x=event->mouse.x;
	*y=event->mouse.y;
}

#ifdef NOTUSED
void popup (Widget w, Widget *box, XtPointer call_data) {
	Position x, y;
	in_popup = 1;
#ifdef athena
	get_coords(&x, &y);
	XtMoveWidget(XtParent(*box), x, y);
#endif
	XtManageChild(*box);
	XtAddCallback(XtParent(*box), XtNpopdownCallback,
		(XtCallbackProc) popdown, NULL);
	XtPopup(XtParent(*box), XtGrabExclusive);
	while (in_popup || XtAppPending(ui.app))
		XtAppProcessEvent(ui.app, XtIMXEvent);
}

void popdown (Widget w, XtPointer client_data, XtPointer call_data) {
        in_popup = 0;
}
#endif

/******************/
/* Event handlers */
/******************/

void redraw_menubar_eh(GR_EVENT *event)
{
  ui.redraw_menubar();
}

void menubar_buttonup_eh(GR_EVENT *event)
{
  ui.menubar_buttonup(event->button.x, event->button.y);
}

void menubar_buttondown_eh(GR_EVENT *event)
{
  /* NOP */
}

void leave_window_eh(GR_EVENT *event)
{
  ui.pause_game();
}

void enter_window_eh(GR_EVENT *event)
{
  ui.resume_game();
}

void redraw_window_eh(GR_EVENT *event)
{
  ui.refresh();
}

void button_press_eh(GR_EVENT *event)
{
  game.button_press(event->button.x, event->button.y);
}

void button_release_eh(GR_EVENT *event)
{
  game.button_release(event->button.x, event->button.y);
}

void timer_eh() 
{
  ui.restart_timer();
  game.update();
}
