/***********************************************************************
*                                                                      *
* COPYRIGHT (c) 2000   Century Software   All Rights Reserved          *
*                                                                      *
* This software is the property of Century Software and shall not be   *
* reproduced or copied in whole or  used in whole or in  part as the   *
* basis for the manufacture or sale of items, nor shall such copy be   *
* sold or constitute part of a sale without written permission.        *
*                                                                      *
* RESTRICTED RIGHTS LEGEND                                             *
*                                                                      *
* Use, duplication,  or disclosure by the government is subject to     *
* restriction as set forth in paragraph (b)(3)(b) of the Rights in     *
* Technical Data and Computer Software clause in DAR 7-104.9(a).       *
*                                                                      *
* CENTURY SOFTWARE                                                     *
* 5284 SOUTH 320 WEST - SUITE C-134                                    *
* MURRAY, UTAH   84107                                                 *
*                                                                      *
************************************************************************
*                                                                      *
* FILENAME: FILETOOLS.H                                                *
*                                                                      *
***********************************************************************/
#ifndef FILETOOLS_H
#define FILETOOLS_H


/*
**
** Imported "Include" Files
**
*/



/*
**
** Global Constant Definitions
**
*/



/*
**
** Global Enumeration Definitions
**
*/



/*
**
** Global Structure Definitions
**
*/



/*
**
** Global Variable Declarations
**
*/



/*
**
**  NAME: splitPath()
**
** USAGE: int splitPath(char *path, char *dir, char *file, char *ext);
**
** DESCR: This function will split the specified path into its directory,
**        filename, and extension components.
**
** PARMS: The "path" paramter is a pointer to a buffer that contains the
**        path to be split. The "dir" parameter is a pointer to a buffer
**        that will hold the directory result. The "file" parameter is
**        a pointer to a buffer that will hold the filename result. The
**        "ext" parameter is a pointer to a buffer that will hold the
**        file extension result.
**
** RETRN: If successful, '0' is returned. If an error occurs during function
**        execution, a non-zero value is returned that describes the error.
**
*/
int splitPath(char *, char *, char *, char *);

#endif /* FILETOOLS_H */
