#include <stdio.h>
#include <stdlib.h>
#include "nano-X.h"
#include "nxlib.h"
/*
 * linked list routines
 *
 * Copyright (c) 2000 Century Software <embedded.centurysoftware.com>
 * Copyright (c) 1998, 1999, 2000 Greg Haerr <greg@censoft.com>
 */

void *
nxItemAlloc(unsigned int size)
{
	return (void *)calloc(size, 1);
}

/* insert at tail of list*/
void
nxListAdd(PNXLISTHEAD pHead,PNXLIST pItem)
{
	if( pHead->tail) {
		pItem->prev = pHead->tail;
		pHead->tail->next = pItem;
	} else
		pItem->prev = NULL;
	pItem->next = NULL;
	pHead->tail = pItem;
	if( !pHead->head)
		pHead->head = pItem;
}

/* insert at head of list*/
void
nxListInsert(PNXLISTHEAD pHead,PNXLIST pItem)
{
	if( pHead->head) {
		pItem->next = pHead->head;
		pHead->head->prev = pItem;
	} else
		pItem->next = NULL;
	pItem->prev = NULL;
	pHead->head = pItem;
	if( !pHead->head)
		pHead->head = pItem;
}

void
nxListRemove(PNXLISTHEAD pHead,PNXLIST pItem)
{
	if( pItem->next)
		pItem->next->prev = pItem->prev;
	if( pItem->prev)
		pItem->prev->next = pItem->next;
	if( pHead->head == pItem)
		pHead->head = pItem->next;
	if( pHead->tail == pItem)
		pHead->tail = pItem->prev;
	pItem->next = pItem->prev = NULL;
}
