#ifndef NXSYS_PROTO_H
#define NXSYS_PROTO_H

/*
 * NXSYS_PROTO.H
 * Copyright 2000, Century Software Embedded Technologies
 */

/* 
 * DESCRIPTION:  This file defines the prototype structure
 *               used to define the system dependent functions
 *               that must be called for each API function
 *
 * AUTHOR:       First draft, Jordan Crouse, 11/27/00
 */

/****** THIS FILE IS FOR INTERNAL LIBRARY USE ONLY ******/

#include "nxsys.h"

#define NXSYS_PROTO_NO_FUNCTION 0x0 /* Use this when no function is available */

typedef struct _nxsysproto
{
  int (*sysdep_set_date)(nxsys_date_t *);
  int (*sysdep_get_date)(nxsys_date_t *);
  int (*sysdep_set_backlight)(unsigned char, unsigned char);
  int (*sysdep_get_cpu_load)(nxsys_cpu_t *);
  int (*sysdep_get_memory_usage)(nxsys_memory_t *);
  int (*sysdep_get_battery)(nxsys_battery_t *);
  int (*sysdep_get_net_value)(char *, char *);
  int (*sysdep_write_net_values)(nxsys_ipaddr_str_t, nxsys_dns_t);
} nxsys_func_t;

#endif
