/***********************************************************************
*                                                                      *
* COPYRIGHT (c) 2000   Century Software   All Rights Reserved          *
*                                                                      *
* This software is the property of Century Software and shall not be   *
* reproduced or copied in whole or  used in whole or in  part as the   *
* basis for the manufacture or sale of items, nor shall such copy be   *
* sold or constitute part of a sale without written permission.        *
*                                                                      *
* RESTRICTED RIGHTS LEGEND                                             *
*                                                                      *
* Use, duplication,  or disclosure by the government is subject to     *
* restriction as set forth in paragraph (b)(3)(b) of the Rights in     *
* Technical Data and Computer Software clause in DAR 7-104.9(a).       *
*                                                                      *
* CENTURY SOFTWARE                                                     *
* 5284 SOUTH 320 WEST - SUITE C-134                                    *
* MURRAY, UTAH   84107                                                 *
*                                                                      *
************************************************************************
*                                                                      *
* FILENAME: sharedclient.h                                             *
*                                                                      *
***********************************************************************/
#ifndef SHAREDCLIENT_H
#define SHAREDCLIENT_H



/*
**
** Imported "Include" Files
**
*/
#include "cmdblock.h"



/*
**
** Global Constant Definitions
**
*/



/*
**
** Global Enumeration Definitions
**
*/



/*
**
** Global Structure Definitions
**
*/



/*
**
** Global Variable Declarations
**
*/
extern WMCmdBlock *cmd_block;



/*
**
**  NAME: clientMemoryCreate()
**
** USAGE: int clientMemoryCreate(void);
**
** DESCR: This function will create a new block of shared memory. The newly
**        created block will be cleared, the command will be set to "none",
**        and the status set to "idle".
**
** PARMS: None.
**
** RETRN: If successful, '0' is returned. If an error occurs during function
**        exeuction, a non-zero value is returned that describes the error.
**
** NOTES: The shared memory handle is written to a file which is used by
**        other clients to attach to the shared memory. The actual location
**        of the file is specified in the "cmdblock.h" file.
**
*/
int clientMemoryCreate(void);



/*
**
**  NAME: clientMemoryAttach()
**
** USAGE: int clientMemoryAttach(void);
**
** DESCR: This function will attach to the WebMedia shared memory command
**        block and initialize the "cmd_block" pointer.
**
** PARMS: None.
**
** RETRN: If successful, '0' is returned. If an error occurs during function
**        execution, a non-zero value is returned that describes the error.
*/
int clientMemoryAttach(void);



/*
**
**  NAME: clientMemoryDetach()
**
** USAGE: int clientMemoryDetach(void);
**
** DESCR: This function will detach from the WebMedia shared memory command
**        block and free all allocated memory.
**
** PARMS: None.
**
** RETRN: If successful, '0' is returned. If an error occurs during function
**        execution, a non-zero value is returned that describes the error.
**
*/
int clientMemoryDetach(void);

#endif /* SHAREDCLIENT_H */
