/***********************************************************************
*                                                                      *
* COPYRIGHT (c) 2000   Century Software   All Rights Reserved          *
*                                                                      *
* This software is the property of Century Software and shall not be   *
* reproduced or copied in whole or  used in whole or in  part as the   *
* basis for the manufacture or sale of items, nor shall such copy be   *
* sold or constitute part of a sale without written permission.        *
*                                                                      *
* RESTRICTED RIGHTS LEGEND                                             *
*                                                                      *
* Use, duplication,  or disclosure by the government is subject to     *
* restriction as set forth in paragraph (b)(3)(b) of the Rights in     *
* Technical Data and Computer Software clause in DAR 7-104.9(a).       *
*                                                                      *
* CENTURY SOFTWARE                                                     *
* 5284 SOUTH 320 WEST - SUITE C-134                                    *
* MURRAY, UTAH   84107                                                 *
*                                                                      *
************************************************************************
*                                                                      *
* FILENAME: sharedserver.h                                             *
*                                                                      *
***********************************************************************/
#ifndef SHAREDSERVER_H
#define SHAREDSERVER_H



/*
**
** Imported "Include" Files
**
*/
#include "cmdblock.h"



/*
**
** Global Constant Definitions
**
*/



/*
**
** Global Enumeration Definitions
**
*/



/*
**
** Global Structure Definitions
**
*/



/*
**
** Global Variable Declarations
**
*/
extern WMCmdBlock *cmd_block;




/*
**
**  NAME: serverMemoryAttach()
**
** USAGE: int serverMemoryAttach(void);
**
** DESCR: This function will recover a pointer to the shared memory block
**        allocated for WebMedia applications. If the shared memory block
**        does not exist, one is created.
**
** PARMS: None.
**
** RETRN: If successful, '0' is returned. If an error occurs during function
**        execution, a non-zero value is returned that describes the error.
**
*/
int serverMemoryAttach(void);



/*
**
**  NAME: serverMemoryDetach()
**
** USAGE: int serverMemoryDetach(void);
**
** DESCR: This function will free the memory allocated from a previous call
**        to the "sharedMemoryAttach()" function.
**
** PARMS: None.
**
** RETRN: If successful, '0' is returned. If an error occurs during function
**        execution, a non-zero value is returned that describes the error.
**
*/
int serverMemoryDetach(void);

#endif /* SHAREDSERVER_H */
