/***********************************************************************
*                                                                      *
* COPYRIGHT (c) 2000   Century Software   All Rights Reserved          *
*                                                                      *
* This software is the property of Century Software and shall not be   *
* reproduced or copied in whole or  used in whole or in  part as the   *
* basis for the manufacture or sale of items, nor shall such copy be   *
* sold or constitute part of a sale without written permission.        *
*                                                                      *
* RESTRICTED RIGHTS LEGEND                                             *
*                                                                      *
* Use, duplication,  or disclosure by the government is subject to     *
* restriction as set forth in paragraph (b)(3)(b) of the Rights in     *
* Technical Data and Computer Software clause in DAR 7-104.9(a).       *
*                                                                      *
* CENTURY SOFTWARE                                                     *
* 5284 SOUTH 320 WEST - SUITE C-134                                    *
* MURRAY, UTAH   84107                                                 *
*                                                                      *
************************************************************************
*                                                                      *
* FILENAME: SRCSVIDEO.H                                                *
*                                                                      *
***********************************************************************/
#ifndef SRCSVIDEO_H
#define SRCSVIDEO_H


/*
**
** Imported "Include" Files
**
*/



/*
**
** Global Constant Definitions
**
*/



/*
**
** Global Enumeration Definitions
**
*/



/*
**
** Global Structure Definitions
**
*/



/*
**
** Global Variable Declarations
**
*/



/*
**
**  NAME: VAPISrcSvideoOpen()
**
** USAGE: int VAPISrcSvideoOpen(void);
**
** DESCR: This function will initialize this module and prepare it for
**        operation.
**
** PARMS: None.
**
** RETRN: If successful, '0' is returned. If an error occurs during function
**        execution, a non-zero value is returned that describes the error.
**
** NOTES: This function must be called before any other functions in this
**        module are called.
**
*/
int VAPISrcSvideoOpen(void);


/*
**
**  NAME: VAPISrcSvideoClose()
**
** USAGE: int VAPISrcSvideoClose(void);
**
** DESCR: This function will close this module and return any used memory
**        to the system.
**
** PARMS: None.
**
** RETRN: If successful, '0' is returned. If an error occurs during function
**        execution, a non-zero value is returned that describes the error.
**
*/
int VAPISrcSvideoClose(void);


/*
**
**  NAME: VAPISrcSvideoSelect()
**
** USAGE: int VAPISrcSvideoSelect(void);
**
** DESCR: This function will select the s-video video source as the system
**        video source.
**
** PARMS: None.
**
** RETRN: If successful, '0' is returned. If an error occurs during function
**        execution, a non-zero value is returned that describes the error.
**
*/
int VAPISrcSvideoSelect(void);

#endif /* SRCSVIDEO_H */
