/***********************************************************************
*                                                                      *
* COPYRIGHT (c) 2000   Century Software   All Rights Reserved          *
*                                                                      *
* This software is the property of Century Software and shall not be   *
* reproduced or copied in whole or  used in whole or in  part as the   *
* basis for the manufacture or sale of items, nor shall such copy be   *
* sold or constitute part of a sale without written permission.        *
*                                                                      *
* RESTRICTED RIGHTS LEGEND                                             *
*                                                                      *
* Use, duplication,  or disclosure by the government is subject to     *
* restriction as set forth in paragraph (b)(3)(b) of the Rights in     *
* Technical Data and Computer Software clause in DAR 7-104.9(a).       *
*                                                                      *
* CENTURY SOFTWARE                                                     *
* 5284 SOUTH 320 WEST - SUITE C-134                                    *
* MURRAY, UTAH   84107                                                 *
*                                                                      *
************************************************************************
*                                                                      *
* FILENAME: state.h                                                    *
*                                                                      *
***********************************************************************/
#ifndef STATE_H
#define STATE_H

/* System header files */
#include <sys/types.h>												// for pid_t data type
#include <limits.h>													// for PATH_MAX

/*
**
** Imported "Include" Files
**
*/



/*
**
** Global Constant Definitions
**
*/



/*
**
** Global Enumeration Definitions
**
*/



/*
**
** Global Structure Definitions
**
*/
typedef struct
{
	int					xPos,										// X Position
						yPos,										// Y Position
						transLvl;									// Transparency level
	pid_t				pid;										// Process of idbug
	char				idFile[PATH_MAX];							// Path of the idbug image file
} idbugdata_t;


/*
**
** Global Variable Declarations
**
*/
extern char state_source[256];
extern int state_channel;
extern int state_channel_max;
extern int state_channel_min;
extern int state_vidwin_xpos;
extern int state_vidwin_ypos;
extern int state_vidwin_width;
extern int state_vidwin_height;
extern char state_html_base[256];
extern int state_sharedmem_id;
extern int state_volumes[4];
extern idbugdata_t state_idbug[3];



/*
**
**  NAME: loadState()
**
** USAGE: int loadState(void);
**
** DESCR: This function will load and parse the state textfile and extract
**        all global variables.
**
** PARMS: None.
**
** RETRN: If successful, '0' is returned. If an error occurs during function
**        execution, a non-zero value is returned that describes the error.
**
*/
int loadState(void);



/*
**
**  NAME: saveState()
**
** USAGE: int saveState(void);
**
** DESCR: This function will save the current global variable set as the
**        state textfile.
**
** PARMS: None.
**
** RETRN: If successful, '0' is returned. If an error occurs during function
**        execution, a non-zero value is returned that describes the error.
**
*/
int saveState(void);

#endif /* STATE_H */


