/***************************************************************************
**								  	  **	
**			Filename: netstrerror.cpp			  **
**			    Chitra Shankaran				  **
**			 National Semiconductors			  **
**				Bangalore				  **
**									  **
***************************************************************************/

#include "netstrerror.h"

char *errmsg;

/****************************************************************************
**									   **
**		Syntax:		printError(int errorno)		  	   **
**									   **
**		Parameters:	error number, an integer		   **
**								  	   **
**		Returns:	String that describes the error	           **
**									   **
**		Comments:	None				  	   **
**								   	   **
****************************************************************************/
char*  printError(int errorno)
{
	errmsg = (char *)malloc(256 * sizeof(char));
	if(errmsg == NULL){
		printf("Malloc Failed\n");
		exit(0);
	}
	bzero(errmsg,sizeof(errmsg));
	switch(errorno)
	{
		case NETSTR_INIT_ERR:
			strcpy(errmsg,"NscStrInit Failed!");
			break;
		case NETSTR_HOOK2SRV_ERR:
			strcpy(errmsg,"Middleware API NscStrHook2Srv Failed!");
			break;
		case NETSTR_GET_NOFILES_ERR:
			strcpy(errmsg,"Middleware API NscStrGetNoFiles Failed!");
			break;
		case NETSTR_MALLOC_ERR:
			strcpy(errmsg,"Allocating Memory using Malloc Failed!");
			break;
		case NETSTR_GET_FILELIST_ERR:
			strcpy(errmsg,"Middleware API NscStrGetFileList 
				Failed!");
			break;
		case NETSTR_SELECT_FILE_ERR:
			strcpy(errmsg,"Middleware API NscStrSelectFile Failed!");
			break;
		case NETSTR_DIR_ERR:
			strcpy(errmsg,"Selected Directory is not Valid!");
			break;
		case NETSTR_FILE_ERR:
			strcpy(errmsg,"Selected File is not Valid!");
			break;
		case NETSTR_OPEN_CURRENT_FILE_ERR:
			strcpy(errmsg,"Middleware API NscStrOpenCurrentFile 
				Failed!");
			break;
		case NETSTR_PLAY_ERR:
			strcpy(errmsg,"Unable to Play! Middleware API NscStrPlay
				 Failed");
			break;
		case NETSTR_STOP_ERR:
			strcpy(errmsg,"Unable to Stop! Middleware API NscStrStop
				 Failed!");
			break;
		case NETSTR_PAUSE_ERR:
			strcpy(errmsg,"Unable to Pause! Middleware API 
				NscStrPause Failed!");
			break;
		case NETSTR_FFWD_ERR:
			strcpy(errmsg,"Unable to FastForward! Middleware API 
				NscStrFastForward Failed!");
			break;
		case NETSTR_REV_ERR:
			strcpy(errmsg,"Unable to Reverse! Middleware API 
				NscStrReverse Failed!");
			break;
		case NETSTR_LOOP_ERR:
			strcpy(errmsg,"Unable to Loop! Middleware API 
				NscStrLoop Failed!");
			break;
		case NETSTR_MUTE_ERR:
			strcpy(errmsg,"Unable to Mute! Middleware API 
				NscStrMute Failed!");
			break;
		case NETSTR_UNMUTE_ERR:
			strcpy(errmsg,"Unable to restore Volume!");
			break;
		case NETSTR_LAUDIO_ERR:
			strcpy(errmsg,"Unable to Adjust Left Audio!");
			break;
		case NETSTR_RAUDIO_ERR:
			strcpy(errmsg,"Unable to Adjust Right Audio!");
			break;
		case NETSTR_RESUME_PLAY_ERR:
			strcpy(errmsg,"Unable to resume Play!");
			break;
		case NETSTR_FLAG_MATCH_ERR:
			strcpy(errmsg,"Flag Bit does not Match!");
			break;
		case NETSTR_NO_INIT_ERR:
			strcpy(errmsg,"Client not connected to MPEG Server!");
			break;
		case NETSTR_UNLOOP_ERR:
			strcpy(errmsg,"Unable to remove Looping!");
			break;
		case NETSTR_PROC_INIT_ERR:
			strcpy(errmsg,"ProcessInit Failed!");
			break;
	} // end of switch
	return errmsg;
}

/***************************************************************************
**									  **
**		Syntax:		freeMem(void)				  **
**									  **
**		Parameters:	None					  **
**									  **
**		Returns:	Nothing					  **
**									  **
**		Comments:	None					  **
**									  **
***************************************************************************/
void freeMem(void)
{
	free(errmsg);//frees the character pointer used
}
