/***********************************************************************
*                                                                      *
* COPYRIGHT (c) 2000   Century Software   All Rights Reserved          *
*                                                                      *
* This software is the property of Century Software and shall not be   *
* reproduced or copied in whole or  used in whole or in  part as the   *
* basis for the manufacture or sale of items, nor shall such copy be   *
* sold or constitute part of a sale without written permission.        *
*                                                                      *
* RESTRICTED RIGHTS LEGEND                                             *
*                                                                      *
* Use, duplication,  or disclosure by the government is subject to     *
* restriction as set forth in paragraph (b)(3)(b) of the Rights in     *
* Technical Data and Computer Software clause in DAR 7-104.9(a).       *
*                                                                      *
* CENTURY SOFTWARE                                                     *
* 5284 SOUTH 320 WEST - SUITE C-134                                    *
* MURRAY, UTAH   84107                                                 *
*                                                                      *
************************************************************************
*                                                                      *
* FILENAME: SRCSVIDEO.CPP                                              *
*                                                                      *
***********************************************************************/



/*
**
** Imported "Include" Files
**
*/
#include <sys/ioctl.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <linux/fs.h>
#include <linux/videodev.h>
#include "audio.h"
#include "status.h"

#include <linux/soundcard.h>

/*
**
** Local Constant Definitions
**
*/
#define VIDEO_DEVICE "/dev/video"
#define AV_CHANNEL		2											/* Audio/Video source channel */


/*
**
** Local Enumeration Definitions
**
*/



/*
**
** Local Structure Definitions
**
*/



/*
**
** Local Variable Declarations
**
*/


/*
**
** This function will initialize this module and prepare it for
** operation.
**
** If successful, '0' is returned. If an error occurs during function
** execution, a non-zero value is returned that describes the error.
**
** This function must be called before any other functions in this
** module are called.
**
*/
int VAPISrcSvideoOpen(void)
{
  // issue status
  VAPIStatusOutStr("s-video source opened");

  // exit with no errors
  return(0);
}



/*
**
** This function will close this module and return any used memory
** to the system.
**
** If successful, '0' is returned. If an error occurs during function
** execution, a non-zero value is returned that describes the error.
**
*/
int VAPISrcSvideoClose(void)
{
  // issue status
  VAPIStatusOutStr("s-video source closed");

  // exit with no errors
  return(0);
}



/*
**
** This function will select the s-video video source as the system
** video source.
**
** If successful, '0' is returned. If an error occurs during function
** execution, a non-zero value is returned that describes the error.
**
*/
int VAPISrcSvideoSelect(void)
{

#ifndef VAPI_STUB

  char buf[256];
  int result,source,vhandle;

  vhandle = open(VIDEO_DEVICE,O_RDONLY);
  if(vhandle < 0)
  {
    sprintf(buf,"no video device: %s",VIDEO_DEVICE);
    VAPIStatusOutStr(buf);
    return(-1);
  }

  source = AV_CHAN_SVIDEO;
  SetAudio(source,0,0);

//  result = ioctl(vhandle,VIDIOC_S_INPUT,&source);
//  if(result < 0)
//  {
//    VAPIStatusOutStr("unable to select s-video source");
//    return(result);
//  }

  close(vhandle);

  // issue status
  VAPIStatusOutStr("s-video source selected");

#endif

  // exit with no errors
  return(0);
}


